'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5325] on 30 July 2003 at 8:58:15 pm'!
Morph subclass: #CarryingMorph
	instanceVariableNames: 'passenger target lambda origin attach '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!
CurveMorph subclass: #CodeBalloonMorph
	instanceVariableNames: 'target cornerName lastContents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!

!CodeBalloonMorph commentStamp: '<historical>' prior: 0!
My instances are ballons (as BalloonMorph) that are not employed in making objects talk (as BalloonMorph), but to actually talk to objects. To understand how these objects are used, take a look at the references of CodeBalloonMorph.!

StringMorph subclass: #EditableStringMorph
	instanceVariableNames: 'cursor focusBackColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!
EditableStringMorph subclass: #CodeStringMorph
	instanceVariableNames: 'bindings target actionSelector arguments history historyPosition original expansions currentPosition '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!

!CodeStringMorph commentStamp: '<historical>' prior: 0!
a CodeStringMorph is like a StringMorph but it knows what to do when its contents are accepted (Enter pressed). As some usage example, you can see WrapperWorldMorph and MorphicWrapper.
Ok, there is something better than me, open a Workspace in a WrapperWorldMorph and after writing something press cmd-p, do you like it? it's a first aproach for a morphic interface with aWorkspace, just let us know what you think. !

EllipseMorph subclass: #GlobingMorph
	instanceVariableNames: 'velocity '
	classVariableNames: 'GlobingOn '
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!
AlignmentMorph subclass: #MethodFrameMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Basic'!
MethodMorph subclass: #MethodMathMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!
MethodHolder subclass: #MethodModel
	instanceVariableNames: 'editSelection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!
Morph subclass: #MorphicWrapper
	instanceVariableNames: 'wrapee '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers'!
MorphicWrapper subclass: #BitmappedMorphicWrapper
	instanceVariableNames: 'image '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers'!
MorphicWrapper subclass: #ClassMorphicWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers'!
Object subclass: #MorphicWrapperConfiguration
	instanceVariableNames: 'codeStringMorphClass codeBalloonMorphClass defaultFont defaultContents defaultColor defaultBorderWidth defaultBorderColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers'!

!MorphicWrapperConfiguration commentStamp: '<historical>' prior: 0!
I represent some defaults value such as the color of the balloon code and other things like that that we do not want to spread in pasteUpMorph and other beasts!

MorphicWrapperConfiguration class
	instanceVariableNames: 'uniqueInstance '!
AlignmentMorph subclass: #RequestBoxMorph
	instanceVariableNames: 'response destiny selector hand '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!
BalloonMorph subclass: #RequestMorph
	instanceVariableNames: 'response '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!
EllipseMorph subclass: #SatelliteMorph
	instanceVariableNames: 'delta ticks1 ticks2 increment1 increment2 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!

!SatelliteMorph commentStamp: '<historical>' prior: 0!
A SatelliteMorph is a morph that continuously moves arround it's owner, just like some kind of weird satellite.
Try (click):
	SatelliteMorph example1
	SatelliteMorph example2
Satellites are employed to represent saved arguments in a MorphicWrapper.
!

SatelliteMorph subclass: #DeferredMessageMorph
	instanceVariableNames: 'receiver arguments selector sendTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!
Morph subclass: #ShakingMorph
	instanceVariableNames: 'intensity target index origin '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Wrappers-Support'!
BookMorph subclass: #SimpleBook
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Books'!

!CarryingMorph methodsFor: 'stepping' stamp: 'LC 6/20/1999 20:07'!
step
	passenger isNil | target isNil ifTrue: [^ self].
	lambda > 1
		ifTrue: 
			[passenger center: target center.
			(attach ifNil: [false])
				ifTrue: 
					[target attachMorph: passenger.
					target shake].
			^ self stop].
	passenger center: origin * (1 - lambda) + (target center * lambda).
	self bounds: (passenger bottomLeft corner: passenger bottomRight + 10).
	lambda _ lambda + 0.1.
	self globe! !

!CarryingMorph methodsFor: 'stepping' stamp: 'LC 6/20/1999 13:51'!
stepTime
	^ 50! !

!CarryingMorph methodsFor: 'stepping' stamp: 'LC 6/19/1999 20:17'!
stop
	super stopStepping.
	self delete! !

!CarryingMorph methodsFor: 'accessing' stamp: 'LC 6/19/1999 20:37'!
attach: aBoolean
	attach _ aBoolean! !

!CarryingMorph methodsFor: 'accessing' stamp: 'LC 6/19/1999 20:15'!
passenger: aMorph
	passenger _ aMorph.
	origin _ aMorph center.! !

!CarryingMorph methodsFor: 'accessing' stamp: 'LC 6/19/1999 20:09'!
target: aMorph
	target _ aMorph! !

!CarryingMorph methodsFor: 'initialization' stamp: 'LC 6/20/1999 11:44'!
initialize
	super initialize.
	self stopStepping.
	lambda _ 0.1.
	origin _ 0 @ 0.
	attach _ false.
	! !

!CarryingMorph methodsFor: 'drawing' stamp: 'mm 6/10/2000 21:17'!
drawOn: aCanvas
	"Experimentation"
	"
	| left right |
	left _ passenger bottomLeft.
	right _ passenger bottomRight.
	0 to: 8 by: 2 do: [:i | aCanvas
			line: left + (0 @ i)
			to: right + (i negated @ i)
			width: 1
			color: Color darkGray]
	"! !


!CarryingMorph class methodsFor: 'instance creation' stamp: 'LC 6/19/1999 20:12'!
carry: passengerMorph to: targetMorph 
	| answer |
	answer _ self new passenger: passengerMorph;
			 target: targetMorph.
	targetMorph world addMorph: answer.
	answer hide.
	answer startStepping.
	^ answer! !

!CarryingMorph class methodsFor: 'instance creation' stamp: 'fg 7/10/2001 20:06'!
carryAndAttach: passengerMorph to: targetMorph 
	| answer |
	Preferences carryingActivated
		ifTrue: [answer _ self new passenger: passengerMorph;
						 target: targetMorph;
						 attach: true.
			targetMorph world addMorph: answer.
			answer startStepping.
			^ answer]. 
	targetMorph attachMorph: passengerMorph! !

!CarryingMorph class methodsFor: 'instance creation' stamp: 'LC 6/22/1999 00:59'!
includeInNewMorphMenu
	^ false! !


!CodeBalloonMorph methodsFor: 'initialization' stamp: 'DAB 6/7/2001 15:41'!
initialize
	super initialize.
	self 
		layoutPolicy: TableLayout new;
		wrapCentering: #center;
		listCentering: #center.! !

!CodeBalloonMorph methodsFor: 'initialization' stamp: 'len 9/27/1998 07:17'!
setCornerName: aSymbol
	cornerName _ aSymbol! !

!CodeBalloonMorph methodsFor: 'initialization' stamp: 'len 10/2/1998 04:46'!
setTarget: aMorph
	target _ aMorph! !

!CodeBalloonMorph methodsFor: 'event handling' stamp: 'LC 11/5/2000 16:37'!
handleKeystroke: anEvent 
	^ self keyStroke: anEvent! !

!CodeBalloonMorph methodsFor: 'event handling' stamp: 'LC 11/5/2000 16:37'!
keyStroke: evt 
	(self string ifNil: [^ self delete])
		keyStroke: evt.
	self computeVertices! !

!CodeBalloonMorph methodsFor: 'event handling' stamp: 'LC 11/5/2000 16:42'!
keyboardFocusChange: aBoolean
	(self string ifNil: [^ self]) keyboardFocusChange: aBoolean
! !

!CodeBalloonMorph methodsFor: 'accessing' stamp: 'len 10/8/1998 05:47'!
bindings: aDictionary
	((self findA: CodeStringMorph) ifNil: [^ self]) bindings: aDictionary! !

!CodeBalloonMorph methodsFor: 'accessing' stamp: 'LC 12/26/1998 10:41'!
contents
	^ (self string ifNil: [^ '']) contents! !

!CodeBalloonMorph methodsFor: 'accessing' stamp: 'LC 11/5/2000 15:44'!
string
	^ self findA: StringMorph! !

!CodeBalloonMorph methodsFor: 'accessing' stamp: 'r++ 2/20/2000 21:51'!
target
	^ target! !

!CodeBalloonMorph methodsFor: 'accessing' stamp: 'LC 12/26/1998 10:41'!
text
	^ (self string ifNil: [^ nil]) text! !

!CodeBalloonMorph methodsFor: 'private' stamp: 'LC 12/26/1998 10:42'!
computeVertices
	| string corners p1 p2 r pref c maxArea rectCorner
	morphPoint  aa newVertices verts dir mbc mp |
	(string _ self string) ifNil: [^ self delete].
	lastContents _ string contents.
	"Construct vertices for a balloon below and to left of anchor"
	c _ string center.
	corners _ (string bounds corners atAll: #(1 4 3 2))
				collect: [ :each | each - c * (1 @ 1.5) + c].
	p1 _ (corners at: 1) + ((0 - string width//3)@0).
	p2 _ (corners at: 1) + ((0 - string width//6)@(string height * 1.5 // 2 )).
	newVertices _ (Array with: p1 with: p2) , corners.
	r _ p1 rect: (corners at: 3).
	corners _ #(bottomRight bottomLeft topLeft topRight).
	pref _ corners indexOf: cornerName.
	maxArea _ 0.
	0 to: 3 do:
		[:i | "Try four rel locations of the balloon for greatest unclipped area"
		rectCorner _ corners atWrap: i+pref+2.
		morphPoint _ (#(bottomRight bottomLeft) includes: rectCorner)
						ifTrue: [#topCenter] ifFalse: [#bottomCenter].
		aa _ ((r align: (r perform: rectCorner)
				with: (mbc _ target boundsInWorld perform: morphPoint))
			intersect: (0@0 extent: target world viewBox extent)) area.
		aa > maxArea ifTrue: [verts _ newVertices.
							maxArea _ aa.
							mp _ mbc].
		dir _ (i+pref) odd ifTrue: [#horizontal] ifFalse: [#vertical].
		newVertices _ newVertices collect: [:p | p flipBy: dir centerAt: c]].
	verts _ verts ifNil: [newVertices].
	mp _ mp ifNil: [mbc].
	self setVertices: verts; align: verts first with: target center + mp // 2! !

!CodeBalloonMorph methodsFor: 'dropping/grabbing' stamp: 'LC 11/5/2000 16:43'!
justDroppedInto: aMorph event: anEvent
	"This message is sent to a dropped morph after it has been dropped on--and been accepted by--a drop-sensitive morph"

	super justDroppedInto: aMorph event: anEvent.
	self delete! !

!CodeBalloonMorph methodsFor: 'change reporting' stamp: 'LC 12/26/1998 10:42'!
changed
	| string |
	(string _ self string) ifNil: [^ super changed].
	string contents = lastContents ifTrue: [^ super changed].
	lastContents _ string contents.
	self computeVertices.
	super changed! !


!CodeBalloonMorph class methodsFor: 'instance creation' stamp: 'sd 11/27/2001 17:39'!
code: str for: morph corner: cornerName 

	
	"Make up and return a balloon for morph.  Find the quadrant 
  

	that clips the text the least, using cornerName as a tie-breaker."

	

	(str isKindOf: EditableStringMorph)

		
		ifTrue: [str focusBackColor: Color transparent].

	
	^ self new color: self color;

	 
		setBorderWidth: self borderWidth borderColor: self borderColor;

	 
		setTarget: morph;

	 
		setCornerName: cornerName;

	 
		addMorph: str! !

!CodeBalloonMorph class methodsFor: 'instance creation' stamp: 'sd 11/27/2001 15:56'!
for: target hand: hnd 

	
	| text balloon |

	
	text _ self codeStringMorphClass new 
					contents: self contents ; 
					font: self font.	
	balloon _ self

code: text

	for: hnd

corner: #buttomRight.

	
	text privateHasFocus: true;

	 
		bindings: hnd world bindings;

	 
		target: target;

	 
		actionSelector: #acceptBalloon:;

	 
		arguments: (Array with: balloon);

	 
		history: (hnd world historyFor: target).


	hnd grabMorph: balloon;

	 
		newKeyboardFocus: balloon.

	
	^ balloon! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 15:54'!
borderColor

	"^ Color black"
	^ MorphicWrapperConfiguration uniqueInstance borderColor! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 15:54'!
borderWidth

	"^ 1"
	^ MorphicWrapperConfiguration uniqueInstance borderWidth! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 15:54'!
codeStringMorphClass

	"^  CodeStringMorph"
	^ MorphicWrapperConfiguration uniqueInstance codeStringMorphClass! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 16:14'!
color

	"^ (Color

r: 1.0

g: 1.0

b: 0.6)"
	^ MorphicWrapperConfiguration uniqueInstance color! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 15:54'!
contents

	"^  ''"
	^ MorphicWrapperConfiguration uniqueInstance contents! !

!CodeBalloonMorph class methodsFor: 'default' stamp: 'sd 11/27/2001 15:53'!
font

	"BalloonMorph balloonFont"
	^ MorphicWrapperConfiguration uniqueInstance font	! !


!EditableStringMorph methodsFor: 'drawing' stamp: 'r++ 11/28/1999 21:26'!
drawCursorOn: aCanvas 
	| x |
	x _ self position x + (self widthFrom: 1 to: self cursor).
	aCanvas
		line: x @ bounds corner y
		to: x @ bounds origin y
		color: Color brown! !

!EditableStringMorph methodsFor: 'drawing' stamp: 'r++ 11/28/1999 21:38'!
drawOn: aCanvas 
	| textBounds |
	hasFocus ifTrue: [aCanvas fillRectangle: self bounds color: self focusBackColor].
	"move a pixel to the right to place the cursor"
	textBounds _ bounds origin + (1 @ 0) corner: bounds corner + (1 @ 0).
	aCanvas
		text: contents
		bounds: textBounds
		font: font
		color: color.
	hasFocus ifTrue: [self drawCursorOn: aCanvas]! !

!EditableStringMorph methodsFor: 'drawing' stamp: 'LC 12/26/1998 00:16'!
widthFrom: start to: stop 
	| ch form |
	^ (start to: stop - 1)
		inject: 0
		into: [:result :each |
			ch _ contents at: each.
			form _ self font characterFormAt: ch.
			result + form width]! !

!EditableStringMorph methodsFor: 'event handling' stamp: 'fg 8/25/2002 18:39'!
keyStroke: evt 
	"Handle a keystroke event."
	| ch |
	ch _ evt keyCharacter.
	ch asciiValue = 1
		ifTrue: 
			[self home.
			^ self fitContents].
	ch asciiValue = 4
		ifTrue: 
			[self end.
			^ self fitContents].
	ch = Character tab
		ifTrue: 
			[evt shiftPressed 
				ifTrue: [self querySymbolBackward: self contents]
				ifFalse: [self querySymbolForward: self contents].
			^ self fitContents]
		ifFalse:
			[self resetExpansions].
	ch = Character backspace
		ifTrue: [evt shiftPressed
				ifTrue: [^ self del]
				ifFalse: [^ self backspace]].
	ch asciiValue = 127 ifTrue: [^ self del].
	ch asciiValue = 28
		ifTrue: 
			[self leftArrow.
			^ self fitContents].
	ch asciiValue = 29
		ifTrue: 
			[self rightArrow.
			^ self fitContents].
	(ch = $x and: [evt commandKeyPressed])
		ifTrue: 
			["cut"
			Clipboard clipboardText: contents.
			^ self contents: ''].
	(ch = $c and: [evt commandKeyPressed])
		ifTrue: 
			["copy"
			Clipboard clipboardText: contents.
			^ self].
	(ch = $v and: [evt commandKeyPressed])
		ifTrue: ["paste"
			^ self paste].
	(evt keyCharacter = Character enter
		or: [evt keyCharacter = Character cr
				or: [evt keyCharacter = $s and: [evt commandKeyPressed]]])
		ifTrue: 
			["accept"
			self acceptContents.
			evt hand keyboardFocus ifNil: [evt hand newKeyboardFocus: evt hand world].
			^ self].
	self addChar: ch!
]style[(14 822 9 121 9 422)f1b,f1,f1cred;,f1,f1cred;,f1! !

!EditableStringMorph methodsFor: 'editing' stamp: 'LC 12/26/1998 00:42'!
addChar: aCharacter
	| ch |
	(self isPrintable: aCharacter) ifFalse: [^ self].
	ch _ aCharacter isSeparator
		ifTrue: [$ ]
		ifFalse: [aCharacter].
	self contents: (contents insert: ch asString at: self cursor).
	self rightArrow.
	self fitContents
! !

!EditableStringMorph methodsFor: 'editing' stamp: 'LC 12/25/1998 11:56'!
backspace
	self cursor = 1 ifTrue: [^ self].
	contents size = 1
		ifTrue: 
			[cursor _ 1.
			self contents: ''.
			^ self].
	self cursor = (contents size + 1)
		ifTrue: 
			[cursor _ cursor - 1.
			self contents: (contents copyFrom: 1 to: contents size - 1).
			^ self].
	self cursor = 2
		ifTrue: 
			[cursor _ 1.
			self contents: (contents copyFrom: 2 to: contents size).
			^ self].
	cursor _ self cursor - 1.
	self contents: (contents copyFrom: 1 to: cursor - 1)
			, (contents copyFrom: cursor + 1 to: contents size)! !

!EditableStringMorph methodsFor: 'editing' stamp: 'LC 12/26/1998 02:16'!
del
	self cursor = (contents size + 1) ifTrue: [^ self].
	contents size = 1 ifTrue:
		[self contents: ''.
		^ self].
	self cursor = 1
		ifTrue: 
			[self contents: (contents copyFrom: 2 to: contents size).
			^ self].
	self cursor = (contents size - 1)
		ifTrue: 
			[self contents: (contents copyFrom: 1 to: contents size - 1).
			^ self].
	self contents: (contents copyFrom: 1 to: self cursor - 1)
			, (contents copyFrom: self cursor + 1 to: contents size)! !

!EditableStringMorph methodsFor: 'editing' stamp: 'LC 12/25/1998 12:29'!
end
	cursor _ contents size + 1! !

!EditableStringMorph methodsFor: 'editing' stamp: 'LC 12/25/1998 12:29'!
home
	cursor _ 1! !

!EditableStringMorph methodsFor: 'editing' stamp: 'LC 12/26/1998 00:45'!
isPrintable: aCharacter
	^ aCharacter asciiValue >= 20! !

!EditableStringMorph methodsFor: 'editing' stamp: 'LC 12/25/1998 12:19'!
leftArrow
	self cursor = 1 ifTrue: [^ self].
	contents size = 1
		ifTrue: 
			[cursor _ 1.
			^ self].
	self cursor = (contents size + 1)
		ifTrue: 
			[cursor _ self cursor - 1.
			^ self].
	self cursor = 2
		ifTrue: 
			[cursor _ 1.
			^ self].
	cursor _ self cursor - 1! !

!EditableStringMorph methodsFor: 'editing' stamp: 'fg 6/30/2001 20:52'!
paste
	self contents: (contents insert: Clipboard clipboardText asString at: self cursor)! !

!EditableStringMorph methodsFor: 'editing' stamp: 'LC 12/25/1998 11:54'!
rightArrow
	self cursor = (contents size + 1) ifTrue: [^ self].
	cursor _ self cursor + 1
! !

!EditableStringMorph methodsFor: 'accessing' stamp: 'fg 8/25/2002 17:50'!
contents: aString
	contents = aString ifTrue: [^ self].  "no substantive change"
	contents _ (aString beginsWith: '  ') ifTrue: [aString] ifFalse: ['  ', aString].
	cursor _ self cursor min: contents size + 1.
	self fitContents.
! !

!EditableStringMorph methodsFor: 'accessing' stamp: 'LC 12/25/1998 12:21'!
cursor
	^ (cursor ifNil: [cursor _ contents size]) min: contents size + 1! !

!EditableStringMorph methodsFor: 'accessing' stamp: 'LC 12/26/1998 02:35'!
fitContents
	| cursorWidth w |
	cursorWidth _ 1.
	w _ (self widthFrom: 1 to: contents size + 1) + cursorWidth.
	self extent: w @ self font height.
	self changed! !

!EditableStringMorph methodsFor: 'accessing' stamp: 'LC 12/26/1998 10:50'!
focusBackColor
	^ focusBackColor ifNil: [Color yellow]! !

!EditableStringMorph methodsFor: 'accessing' stamp: 'LC 12/26/1998 10:50'!
focusBackColor: aColor
	focusBackColor _ aColor! !

!EditableStringMorph methodsFor: 'accessing' stamp: 'LC 12/26/1998 01:59'!
font
	^ font
		ifNil: 
			[self font: BalloonMorph balloonFont.
			font]! !

!EditableStringMorph methodsFor: 'initialization' stamp: 'LC 12/26/1998 00:25'!
initialize
	super initialize.
	self contents: 'EditableStringMorph'.
	cursor _ contents size + 1! !


!CodeStringMorph methodsFor: 'editing' stamp: 'r++ 1/14/1999 14:39'!
acceptContents
	super acceptContents.
	self restoreHistory.
	self contents isEmpty ifTrue: [^ self delete].
	self addToHistory.
	self arguments isNil
		ifTrue: [self target perform: self actionSelector]
		ifFalse: [self target perform: self actionSelector withArguments: self arguments].
	self restoreHistory.
	self addToHistory.
! !

!CodeStringMorph methodsFor: 'editing' stamp: 'len 11/12/1998 05:17'!
addToHistory
	((historyPosition between: 1 and: self history size)
		and: [self contents = (self history at: historyPosition)])
			ifTrue: [self history removeAt: historyPosition.
					historyPosition = 1 ifFalse: [self history removeFirst]].
	(self history isEmpty not and: [self history first = self contents]) ifTrue: [^ self].
	self history addFirst: self contents.
	self history size > self class maxHistory ifTrue: [self history removeLast]! !

!CodeStringMorph methodsFor: 'editing' stamp: 'LC 5/12/2000 13:47'!
correctFrom: start to: stop with: string
	self contents: (self intendedMessage copyReplaceFrom: start to: stop with: string)
! !

!CodeStringMorph methodsFor: 'editing' stamp: 'LC 10/31/1998 20:40'!
deselect! !

!CodeStringMorph methodsFor: 'editing' stamp: 'LC 12/26/1998 00:27'!
historyDown
	historyPosition > 1
		ifTrue: [historyPosition _ historyPosition - 1]
		ifFalse: [^ self flash; changed].
	self contents: (self history at: historyPosition); end! !

!CodeStringMorph methodsFor: 'editing' stamp: 'LC 12/26/1998 00:27'!
historyUp
	historyPosition = 0
		ifTrue: [self addToHistory.
				historyPosition _ 1].
	historyPosition < self history size
		ifTrue: [historyPosition _ historyPosition + 1]
		ifFalse: [^ self flash; changed].
	self contents: (self history at: historyPosition); end! !

!CodeStringMorph methodsFor: 'editing' stamp: 'fg 8/26/2002 20:17'!
initialzeExpansionsWith: aString

	original ifNil: 
		[original _ aString withBlanksTrimmed. 
		expansions _ original isEmpty 
			ifTrue: [original _ nil. #('  ')]
			ifFalse: [(target wrapee class allSelectors select: [:e | e asString beginsWith: original])].
		expansions _ expansions asSortedCollection.
		currentPosition _ 0]! !

!CodeStringMorph methodsFor: 'editing' stamp: 'LC 5/12/2000 13:12'!
notify: aString at: location in: source
	self contents: (source contents insert: '"' , aString , '"' at: location).
	self color: Color red.
	self addToHistory! !

!CodeStringMorph methodsFor: 'editing' stamp: 'fg 8/25/2002 18:40'!
querySymbolBackward: aString

	self initialzeExpansionsWith: aString.
	expansions isEmpty ifTrue: [^ self].
	currentPosition _ currentPosition - 1.
	currentPosition <= 0 ifTrue: [currentPosition _ expansions size].
	self contents: (expansions at: currentPosition).
	self end
! !

!CodeStringMorph methodsFor: 'editing' stamp: 'fg 8/25/2002 18:34'!
querySymbolForward: aString

	self initialzeExpansionsWith: aString.
	expansions isEmpty ifTrue: [^ self].
	currentPosition _ (currentPosition \\ expansions size) + 1.
	self contents: (expansions at: currentPosition).
	self end
! !

!CodeStringMorph methodsFor: 'editing' stamp: 'fg 8/25/2002 18:06'!
resetExpansions
	original _ nil! !

!CodeStringMorph methodsFor: 'editing' stamp: 'lc 5/5/1999 23:10'!
restoreHistory
	historyPosition ~= 0 ifTrue: [self history removeFirst]! !

!CodeStringMorph methodsFor: 'editing' stamp: 'LC 10/31/1998 20:39'!
select! !

!CodeStringMorph methodsFor: 'editing' stamp: 'LC 10/31/1998 20:39'!
selectFrom: start to: stop! !

!CodeStringMorph methodsFor: 'editing' stamp: 'LC 10/31/1998 20:41'!
selectInvisiblyFrom: start to: stop! !

!CodeStringMorph methodsFor: 'editing' stamp: 'r++ 11/27/97 22:21'!
selectionInterval
	"Answer the interval that is currently selected."

	^ 1 to: self contents size! !

!CodeStringMorph methodsFor: 'event handling' stamp: 'r++ 11/7/1999 12:23'!
delete
	self releaseKeyboardFocus.
	^ super delete! !

!CodeStringMorph methodsFor: 'event handling' stamp: 'r++ 11/7/1999 12:10'!
keyStroke: evt
	"Handle a keystroke event."
	evt keyCharacter asciiValue = 27 "escape" ifTrue: [
		evt hand newKeyboardFocus: nil.
		^ self restoreHistory; delete].
	evt keyCharacter asciiValue = 30 "up" ifTrue: [^ self historyUp].
	evt keyCharacter asciiValue = 31 "down" ifTrue: [^ self historyDown].
	super keyStroke: evt
! !

!CodeStringMorph methodsFor: 'event handling' stamp: 'LC 11/5/2000 16:05'!
releaseKeyboardFocus
	self world
		ifNotNil: [self world hands
				do: [:eHand | (eHand keyboardFocus = self owner
							or: [eHand keyboardFocus = self])
						ifTrue: [eHand newKeyboardFocus: nil]]]! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'r++ 11/27/97 22:21'!
actionSelector
	^ actionSelector! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'r++ 11/27/97 22:21'!
actionSelector: aSymbol
	actionSelector _ aSymbol! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'r++ 11/27/97 22:21'!
arguments
	^ arguments! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'r++ 11/27/97 22:21'!
arguments: anArray
	arguments _ anArray! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'r++ 11/27/97 22:21'!
bindings
	^ bindings! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'r++ 11/27/97 22:21'!
bindings: aDictionary
	bindings _ aDictionary! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'len 9/8/1998 08:03'!
history
	^ history! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'len 9/8/1998 08:03'!
history: anOrderedCollection
	history _ anOrderedCollection! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'r++ 11/28/1999 21:44'!
privateHasFocus: focus
	hasFocus _ focus! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'r++ 11/27/97 22:21'!
target
	^ target! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'r++ 11/27/97 22:21'!
target: anObject
	target _ anObject! !

!CodeStringMorph methodsFor: 'accessing' stamp: 'r++ 11/27/97 22:21'!
text
	^ self contents asText! !

!CodeStringMorph methodsFor: 'drawing' stamp: 'LC 12/10/2000 18:32'!
flash
	| old |
	old _ self color.
	self color: Color transparent.
	"self isInWorld ifTrue: [self world displayWorld]."
	(Delay forMilliseconds: 10) wait.
	self color: old! !

!CodeStringMorph methodsFor: 'binding' stamp: 'r++ 11/27/97 22:21'!
bindingOf: aString
	(self bindings includesKey: aString)
		ifFalse: [self bindings at: aString put: nil].
	^ self bindings associationAt: aString! !

!CodeStringMorph methodsFor: 'initialization' stamp: 'len 10/3/1998 04:51'!
initialize
	super initialize.
	historyPosition _ 0! !

!CodeStringMorph methodsFor: 'private' stamp: 'LC 7/8/2000 19:30'!
intendedMessage
	"Should we add 'self' or not?"
	| aString string first beginning strm var index receiver |
	aString _ self contents.
	string _ aString withBlanksTrimmed.
	string isEmpty ifTrue: [^ aString].
	first _ string first.
	beginning _ string firstAlphaNumericSubstring.

	"Globals"
	(Smalltalk includesKey: beginning asSymbol)
		ifTrue: [^ aString].

	"Uppercases"
	first isUppercase ifTrue: [^ aString].

	"Reserved names"
	"ClassBuilder new reservedNames"
	(#('true' 'false' 'nil' 'thisContext') includes: beginning) ifTrue: [^ string].

	"numbers"
	first isDigit ifTrue: [^ aString].

	"self"
	string = 'self' ifTrue: [^ aString].
	(string beginsWith: 'self ')
		ifTrue: [^ aString].

	"super"
	string = 'super' ifTrue: [^ aString].
	(string beginsWith: 'super ')
		ifTrue: [^ aString].

	"special symbols"
	(#($( $' $# $$ ${ $[) includes: first)
		ifTrue: [^ aString].

	"$_ assignemts"
	strm _ ReadStream on: aString.
	var _ (strm nextDelimited: $_) withBlanksTrimmed.
	((var includes: $ )
		or: [strm atEnd])
		ifFalse: [^ aString].

	"':=' asignments"
	index _ string findString: ':='.
	strm reset; upTo: $ ; skipSeparators.
	(strm position >= (index - 1) and: [index > 0])
		ifTrue: [^ aString].

	"bindings"
	(World bindings includesKey: beginning)
		ifTrue: [^ string].

	receiver _ target receiver.
	"inst var names"
	((receiver class allInstVarNames includes: string)
		and: [(receiver respondsTo: string asSymbol) not]) ifTrue: [^ string].

	"Parser conflicts"
	(first = $- and: [(receiver respondsTo: #-) not])
		ifTrue: [^ string].

	^ 'self ' , aString
! !


!CodeStringMorph class methodsFor: 'defaults' stamp: 'len 9/7/1998 23:55'!
maxHistory
	^ 100! !


!GlobingMorph methodsFor: 'stepping' stamp: 'LC 6/20/1999 20:54'!
step
	self isInWorld ifFalse: [^ self stop].
	(self bounds intersects: self world fullBounds)
		ifFalse: [^ self stop].
	self center: self center + velocity! !

!GlobingMorph methodsFor: 'stepping' stamp: 'LC 6/20/1999 19:56'!
stepTime
	^ 0! !

!GlobingMorph methodsFor: 'stepping' stamp: 'LC 6/20/1999 19:49'!
stop
	super stop.
	self delete! !

!GlobingMorph methodsFor: 'accessing' stamp: 'LC 6/20/1999 19:59'!
velocity
	^ velocity! !

!GlobingMorph methodsFor: 'accessing' stamp: 'LC 6/20/1999 19:59'!
velocity: aPoint
	velocity _ aPoint! !

!GlobingMorph methodsFor: 'initialization' stamp: 'LC 6/20/1999 22:01'!
initialize
	| d |
	super initialize.
	self color: Color transparent.
	d _ 15 atRandom.
	self extent: d @ d.
	velocity _ 0 @ -1! !


!GlobingMorph class methodsFor: 'preferences' stamp: 'LC 6/20/1999 20:30'!
globingOff
	"
	GlobingMorph globingOff
	"
	GlobingOn _ false! !

!GlobingMorph class methodsFor: 'preferences' stamp: 'LC 6/20/1999 20:30'!
globingOn
	"
	GlobingMorph globingOn
	"
	GlobingOn _ true! !

!GlobingMorph class methodsFor: 'preferences' stamp: 'LC 6/20/1999 20:53'!
isGlobingOn
	^ GlobingOn! !

!GlobingMorph class methodsFor: 'class initialization' stamp: 'LC 9/11/1999 08:06'!
initialize
	"
	GlobingMorph initialize
	"
	GlobingOn _ false! !


!MethodFrameMorph methodsFor: 'updating' stamp: 'LC 3/17/2000 17:35'!
activate
	| m |
	m _ self methodPane model.
	m modelWakeUp.
	self update: self
! !

!MethodFrameMorph methodsFor: 'updating' stamp: 'LC 3/17/2000 20:06'!
model
	^ self methodPane model! !

!MethodFrameMorph methodsFor: 'updating' stamp: 'LC 3/17/2000 19:53'!
update: aSymbol
	| m |
	m _ self methodPane model.
	( self title findA: StringMorph )
		contents: m labelString.
	owner update: aSymbol! !

!MethodFrameMorph methodsFor: 'misc' stamp: 'LC 3/17/2000 15:14'!
close
	| m |
	m _ self methodPane.
	(m isNil or: [m hasUnacceptedEdits not])
		ifTrue: [^ self delete].
	(self confirm: 'Changes have not been saved.
Is it OK to cancel those changes?')
		ifFalse: [^ self].
	self delete! !

!MethodFrameMorph methodsFor: 'misc' stamp: 'LC 3/17/2000 14:49'!
closeBox
	| font x e d |
	x _ $X.
	font _ Preferences standardButtonFont.
	e _ (font characterFormAt: x) extent.
	d _ e max: e transposed.
	^ SimpleButtonMorph new borderWidth: 0;
	 label: x asString font: font;
	 color: Color transparent;
	 actionSelector: #close;
	 target: self;
	 extent: d;
	 setBalloonText: 'close window'! !

!MethodFrameMorph methodsFor: 'misc' stamp: 'LC 3/16/2000 19:14'!
collapseButtom
	| font x e d |
	x _ $O.
	font _ Preferences standardButtonFont.
	e _ (font characterFormAt: x) extent.
	d _ e max: e transposed.
	^ SimpleButtonMorph new
	 label: x asString font: font;
	 color: Color transparent;
	 actionSelector: #collapse;
	 target: self;
	 extent: d;
	 borderWidth: 0;
	 setBalloonText: 'collapse window'! !

!MethodFrameMorph methodsFor: 'misc' stamp: 'LC 3/16/2000 19:36'!
isCollapsed
	^ self methodPane visible not! !

!MethodFrameMorph methodsFor: 'misc' stamp: 'LC 3/17/2000 15:26'!
menuControl
	^ IconicButton new borderWidth: 0;
	 labelGraphic: (ScriptingSystem formAtKey: 'TinyMenu');
	 color: Color transparent;
	 actWhen: #buttonDown;
	 actionSelector: #offerWindowMenu;
	 target: self;
	 setBalloonText: 'window menu';
	 name: 'menuControl'! !

!MethodFrameMorph methodsFor: 'misc' stamp: 'LC 3/16/2000 19:21'!
methodPane
	^ self submorphNamed: 'methodPane'! !

!MethodFrameMorph methodsFor: 'misc' stamp: 'LC 3/17/2000 15:27'!
offerWindowMenu
	self methodPane offerWindowMenu! !

!MethodFrameMorph methodsFor: 'misc' stamp: 'LC 3/17/2000 13:47'!
title
	^ (self submorphNamed: 'title')
		ifNil: [self initializeTitle.
		(self submorphNamed: 'title') ifNil: []]! !

!MethodFrameMorph methodsFor: 'misc' stamp: 'LC 3/16/2000 19:23'!
titleString
	| method |
	(method _ self submorphNamed: 'methodPane') ifNil: [^ ''].
	^ (method model ifNil: [^ '']) labelString! !

!MethodFrameMorph methodsFor: 'menus' stamp: 'LC 3/17/2000 16:24'!
collapse
	self isCollapsed ifTrue: [^ self expand].
	self vResizing: #rigid.
	self hResizing: #rigid.
	self methodPane hide.
	self extent: self title extent.

! !

!MethodFrameMorph methodsFor: 'menus' stamp: 'LC 3/17/2000 16:42'!
expand

	self vResizing: #shrinkWrap.
	self hResizing: #shrinkWrap.
	self layoutChanged.
	self methodPane show! !

!MethodFrameMorph methodsFor: 'initialization' stamp: 'LC 12/10/2000 18:11'!
initialize
	super initialize vResizing: #shrinkWrap;
	 hResizing: #shrinkWrap;
	 color: Color transparent;
	 cornerStyle: #rounded;
	 borderColor: Color black;
	 borderWidth: 0;
	 listDirection: #topToBottom;
	 layoutInset: 0;
	 addMorph: self title! !

!MethodFrameMorph methodsFor: 'initialization' stamp: 'LC 12/10/2000 18:13'!
initializeTitle
	| titleMorph |
	titleMorph _ AlignmentMorph new vResizing: #shrinkWrap;
			 wrapCentering: #center "#bottomRight";
			 color: (Color r: 1.0 g: 0.8 b: 0.4);
			 cornerStyle: #rounded;
			 borderColor: Color black;
			 borderWidth: 1;
			 disableDragNDrop;
			 layoutInset: 1.

	titleMorph
			 addMorph: self collapseButtom;
			 addMorph: (StringMorph contents: self titleString) lock;
			 addMorph: self menuControl;
			 addMorph: self closeBox;
			 name: 'title'.
	titleMorph position: self position - (0 @ 23).
	self addMorph: titleMorph! !

!MethodFrameMorph methodsFor: 'initialization' stamp: 'LC 3/17/2000 20:17'!
initializeTitle2
	| titleMorph |
	titleMorph _ AlignmentMorph new vResizing: #shrinkWrap;
			 centering: #center "#bottomRight";
			 color: (Color r: 1.0 g: 0.8 b: 0.4);
			 cornerStyle: #rounded;
			 borderColor: Color black;
			 borderWidth: 1;
			 openToDragNDrop: false;
			 inset: 1.

	titleMorph
			 addMorph: self collapseButtom;
			 addMorph: (StringMorph contents: self titleString) lock;
			 addMorph: self menuControl;
			 addMorph: self closeBox;
			 name: 'title'.
	titleMorph position: self position - (0 @ 23).
	self addMorph: titleMorph! !

!MethodFrameMorph methodsFor: 'initialization' stamp: 'LC 3/17/2000 21:14'!
initializeTitle3
	| titleMorph collapse label menu close sep pos x y |
	titleMorph _ BorderedMorph new
			 color: (Color r: 1.0 g: 0.8 b: 0.4);
			 cornerStyle: #rounded;
			 borderColor: Color black;
			 borderWidth: 1.
	titleMorph position: (pos _ self position).
	close _ self closeBox.
	close position: pos + 1.
	sep _ 5.
	x _ close right + sep.
	y _ close center y.

	menu _ self menuControl.
	menu center: x @ y.

	x _ menu right + sep.
	label _ StringMorph contents: self titleString.
	label width: self right - x - (x - self left).
	label center: x @ y.

	collapse _ self collapseButtom.
	x _ self right - sep - collapse width.
	collapse center: x @ y.

	titleMorph
			 addMorph: close;
			 addMorph: menu;
			 addMorph: label;
			 addMorph: collapse;
			 name: 'title'.
	titleMorph bounds: titleMorph fullBounds.
	self addMorph: titleMorph! !


!MethodMathMorph methodsFor: 'menus' stamp: 'LC 2/3/2000 16:24'!
buildMenu
	| menu |
	menu _ MenuMorph new.
	menu defaultTarget: self.
	menu addStayUpItem.
	menu add: 'get class' action: #getClass.
	menu add: 'pretty print' action: #prettyPrint.
	menu add: 'change color' action: #changeColor.
	^ menu! !

!MethodMathMorph methodsFor: 'menus' stamp: 'LC 2/3/2000 16:09'!
collapse
	self isCollapsed ifTrue: [^ self expand].
	self extent: 0 @ 0.
	self borderColor: Color transparent.
	self position: self title position.
	self title position: self position! !

!MethodMathMorph methodsFor: 'menus' stamp: 'LC 2/3/2000 15:39'!
expand
	| t |
	self extent: 400 @ 130.
	t _ self title.
	self position: t position + (0 @ 23).
	t position: self position - (0 @ 23).
	self borderColor: Color black.
! !

!MethodMathMorph methodsFor: 'menus' stamp: 'LC 2/3/2000 08:16'!
getClass
	| c morph |
	morph _ ((c _ self methodClass) isMeta
		ifTrue: [c theNonMetaClass]
		ifFalse: [c]) asMorph.
	self currentHand attachMorph: morph! !

!MethodMathMorph methodsFor: 'menus' stamp: 'LC 2/3/2000 16:08'!
isCollapsed
	^ self position = self title position! !

!MethodMathMorph methodsFor: 'menus' stamp: 'LC 11/5/2000 16:59'!
offerWindowMenu
	| menu evt |
	evt _ self currentEvent.
	menu _ self buildMenu.
	self model
		addModelMenuItemsTo: menu
		forMorph: self
		hand: evt hand.
	menu popUpAt: self cursorPoint forHand: evt hand in: self world! !

!MethodMathMorph methodsFor: 'stepping' stamp: 'LC 1/28/2000 22:01'!
step
	"do nothing"! !

!MethodMathMorph methodsFor: 'stepping' stamp: 'LC 2/3/2000 15:09'!
wantsSteps
	^ false! !

!MethodMathMorph methodsFor: 'misc' stamp: 'LC 2/2/2000 16:14'!
closeBox
	| font x e d |
	x _ $X.
	font _ Preferences standardButtonFont.
	e _ (font characterFormAt: x) extent.
	d _ e max: e transposed.
	^ SimpleButtonMorph new borderWidth: 0;
	 label: x asString font: font;
	 color: Color transparent;
	 actionSelector: #delete;
	 target: self;
	 extent: d;
	 setBalloonText: 'close window'! !

!MethodMathMorph methodsFor: 'misc' stamp: 'LC 2/3/2000 16:10'!
collapseButtom
	| font x e d |
	x _ $O.
	font _ Preferences standardButtonFont.
	e _ (font characterFormAt: x) extent.
	d _ e max: e transposed.
	^ SimpleButtonMorph new
	 label: x asString font: font;
	 color: Color transparent;
	 actionSelector: #collapse;
	 target: self;
	 extent: d;
	 borderWidth: 0;
	 setBalloonText: 'collapse window'! !

!MethodMathMorph methodsFor: 'misc' stamp: 'LC 2/3/2000 15:10'!
menuControl
	^ IconicButton new borderWidth: 0;
	 labelGraphic: (ScriptingSystem formAtKey: 'TinyMenu');
	 color: Color transparent;
	 actWhen: #buttonDown;
	 actionSelector: #offerWindowMenu;
	 target: self;
	 setBalloonText: 'window menu'! !

!MethodMathMorph methodsFor: 'misc' stamp: 'LC 1/28/2000 21:28'!
titleString
	^ (model ifNil: [^ nil]) labelString! !

!MethodMathMorph methodsFor: 'updating' stamp: 'LC 3/16/2000 19:17'!
activate
	self model modelWakeUp! !

!MethodMathMorph methodsFor: 'updating' stamp: 'LC 3/17/2000 17:34'!
update: aSymbol
	super update: aSymbol.
	owner update: aSymbol! !

!MethodMathMorph methodsFor: 'model access' stamp: 'LC 1/28/2000 19:08'!
methodClass
	^ (model ifNil: [^ nil]) methodClass
! !

!MethodMathMorph methodsFor: 'model access' stamp: 'LC 1/28/2000 19:08'!
methodSelector
	^ (model ifNil: [^ nil]) methodSelector
! !

!MethodMathMorph methodsFor: 'pane events' stamp: 'LC 2/2/2000 12:35'!
handlesMouseDown: evt
	^ true! !

!MethodMathMorph methodsFor: 'pane events' stamp: 'LC 11/12/2000 10:37'!
mouseDown: evt 
	| pos handle |
	(super handlesMouseDown: evt)
		ifTrue: [super mouseDown: evt].
	evt redButtonPressed
		ifTrue: [owner comeToFront].
	pos _ evt cursorPoint.
	(self bottomRight dist: pos)
			< 10
		ifTrue: [handle _ HandleMorph new.
			handle
				forEachPointDo: [:pt | pt]
				lastPointDo: [:pt | self
						extent: ((self griddedPoint: pt)
								- self bounds topLeft max: self minExtent)].
			evt hand attachMorph: handle.
			handle startStepping]! !

!MethodMathMorph methodsFor: 'pane events' stamp: 'LC 2/2/2000 12:28'!
mouseEnter: event 
	super mouseEnter: event.
	self activate! !

!MethodMathMorph methodsFor: 'initialization' stamp: 'LC 3/16/2000 19:15'!
initialize
	super initialize."
	self submorphsDo: [:each | each lock].
	self addMorph: self title."
	self color: (Color r: 0.599 g: 1.0 b: 0.8)
! !


!MethodModel methodsFor: 'accessing' stamp: 'LC 1/28/2000 14:50'!
classField
	self updateClass.
	^ methodClass ! !

!MethodModel methodsFor: 'accessing' stamp: 'LC 1/28/2000 14:56'!
classification
	^ (self classField organization categoryOfElement: self selector) ifNil: [ClassOrganizer default]! !

!MethodModel methodsFor: 'accessing' stamp: 'fg 8/4/2001 12:23'!
classification: aString
	| org category |
	((aString isKindOf: String) not or: [aString size = 0]) ifTrue: [^ self].
	category _ self classification.
	org _ self selectedClassOrMetaClass organization.
	org classify: methodSelector under: aString asString.
	(org listAtCategoryNamed: category)
		isEmpty ifTrue: [org removeCategory: category].
	Smalltalk logChange:
		self selectedClass name, ' organization classify: #', methodSelector, ' under: ', aString asString printString.
	self 
		changed: #relabel;
		changed: #annotation! !

!MethodModel methodsFor: 'accessing' stamp: 'LC 1/28/2000 14:55'!
contents
	^ editSelection = #byteCodes
		ifTrue: [(self classField compiledMethodAt: self selector ifAbsent: [^ super contents]) symbolic asText]
		ifFalse: [super contents]! !

!MethodModel methodsFor: 'accessing' stamp: 'fg 8/1/2001 18:55'!
labelString
	^ self selectedClassOrMetaClass name , ' | ' , (self selector ifNil: ['<unknown selector>'])! !

!MethodModel methodsFor: 'accessing' stamp: 'LC 1/28/2000 19:27'!
methodClass
	^ methodClass ! !

!MethodModel methodsFor: 'accessing' stamp: 'LC 1/28/2000 19:27'!
methodSelector
	^ methodSelector ! !

!MethodModel methodsFor: 'accessing' stamp: 'LC 1/28/2000 14:53'!
selector
	^ methodSelector! !

!MethodModel methodsFor: 'accessing' stamp: 'LC 1/28/2000 14:56'!
source
	self selector isNil ifTrue: [^ ''].
	(self classField isKindOf: Behavior)
		ifFalse: [^ '<<invalid class>>'].
	(self classField selectors includes: self selector)
		ifFalse: [^ self selector asString , '
	<<method not found>>'].
	^ self classField sourceMethodAt: self selector ifAbsent: [self selector asString , '
	<<source code not found>>']! !

!MethodModel methodsFor: 'menu' stamp: 'LC 12/24/1998 13:08'!
addCategory
	RequestBoxMorph
		request: 'Category?'
		respondTo: self
		selector: #classification:
! !

!MethodModel methodsFor: 'menu' stamp: 'LC 6/21/1999 22:25'!
addMenuForClass: aClass toMenu: aSubMenu isSuperOf: aSubClass 
	aClass isNil ifTrue: [^ self].
	aClass organization categories asSortedCollection do: [:each |
		(aSubClass isNil or: [(aSubClass organization categories includes: each) not])
			ifTrue: [aSubMenu
					add: (each = self classification
							ifTrue: [each , ' -:']
							ifFalse: [each])
					target: self
					selector: #classification:
					argumentList: (Array with: each)]]! !

!MethodModel methodsFor: 'menu' stamp: 'fg 7/31/2001 20:41'!
addModelItemsToWindowMenu: aMenu
	^ self buildMenuInto: aMenu! !

!MethodModel methodsFor: 'menu' stamp: 'fg 7/31/2001 20:34'!
addModelMenuItemsTo: aMenu forMorph: aMorph hand: aHandMorph 
	^ self buildMenuInto: aMenu
	! !

!MethodModel methodsFor: 'menu' stamp: 'fg 8/4/2001 08:04'!
buildMenuInto: aMenu
	| submenu sendersMenu implementorsMenu |
	aMenu addLine.
	aMenu 
		add: 'grab method' target: self action: #grabMethod;
		add: 'versions' target: self selector: #browseVersions;
		addLine;
		add: 'remove selector' target: self selector: #remove.
	sendersMenu _ MenuMorph new
				add: 'senders'
				target: self
				selector: #senders;
			
				add: 'local senders'
				target: self
				selector: #localSenders;
			
				add: 'project senders'
				target: self
				selector: #projectSenders;
			 yourself.
	implementorsMenu _ MenuMorph new
				add: 'implementors'
				target: self
				selector: #implementors;
			
				add: 'local implementors'
				target: self
				selector: #localImplementors;
			
				add: 'project implementors'
				target: self
				selector: #projectImplementors;
			 yourself.
	submenu _ MenuMorph new
		add: 'new category... ' target: self selector: #addCategory;
		addLine.
	self
		addMenuForClass: self classField superclass
		toMenu: submenu
		isSuperOf: self classField.
	submenu addLine.
	self
		addMenuForClass: self classField
		toMenu: submenu
		isSuperOf: nil.
	aMenu
		addLine; add: 'senders' subMenu: sendersMenu;
		add: 'implementors' subMenu: implementorsMenu;
		addLine;
		add: 'category' subMenu: submenu;
		addLine;
		add: 'inst var references' target: self classField selector: #browseInstVarRefs;
		add: 'class var references' target: self classField theNonMetaClass selector: #browseClassVarRefs;
		addLine;
		add: 'inspect parse tree' target: self selector: #parseTree;
		yourself.
	^ aMenu! !

!MethodModel methodsFor: 'menu' stamp: 'LC 1/28/2000 14:56'!
implementors
	Smalltalk browseAllImplementorsOf: self selector
! !

!MethodModel methodsFor: 'menu' stamp: 'LC 1/28/2000 14:56'!
localImplementors
	| list |
	list _ SortedCollection new.
	self classField
		allSuperclassesDo: [:c | (c includesSelector: self selector)
				ifTrue: [list add: c name , ' ' , self selector]];
	
		withAllSubclassesDo: [:c | (c includesSelector: self selector)
				ifTrue: [list add: c name , ' ' , self selector]].
	Smalltalk browseMessageList: list name: 'localImplementors of ' , self selector! !

!MethodModel methodsFor: 'menu' stamp: 'fg 8/1/2001 18:58'!
localSenders
	self selectedClassOrMetaClass browseAllCallsOn: methodSelector
! !

!MethodModel methodsFor: 'menu' stamp: 'fg 8/3/2001 15:09'!
messageListMenu: aMenu shifted: shifted
	self toBeImplemented.
	"The following line will correctly build the menu, but the target should be a TextMorphEditor (and not a  MethodModel), and thus each item will cause an DNU error"
	^ self codePaneMenu: aMenu shifted: shifted! !

!MethodModel methodsFor: 'menu' stamp: 'LC 1/28/2000 14:54'!
parseTree
	(self classField decompilerClass new
		decompile: self selector
		in: self classField
		method: (self classField compiledMethodAt: self selector)) inspect! !

!MethodModel methodsFor: 'menu' stamp: 'LC 1/10/2000 09:15'!
prettyPrint
	"Reformat the selected method"
	self okToChange ifFalse: [^ self changed: #flash].
	self contents: (self classField compilerClass new
			format: self contents
			in: self classField
			notifying: nil
			decorated: false)
		notifying: nil.
	self changed: #contents! !

!MethodModel methodsFor: 'menu' stamp: 'LC 1/28/2000 14:53'!
projectImplementors
	| list |
	list _ SortedCollection new.
	Project current projectChangeSet changedClasses do: [:c | (c includesSelector: methodSelector)
			ifTrue: [list add: c name , ' ' , methodSelector]].
	Smalltalk browseMessageList: list name: 'Project implementors of ' , methodSelector! !

!MethodModel methodsFor: 'menu' stamp: 'LC 1/28/2000 14:54'!
projectSenders
	| list |
	list _ SortedCollection new.
	Project current projectChangeSet changedClasses
		do:
			[:c |
			list addAll: ((c whichSelectorsReferTo: methodSelector)
				collect: [:sel | c name , ' ' , sel])].
	Smalltalk
		browseMessageList: list
		name: 'Project senders of ' , methodSelector! !

!MethodModel methodsFor: 'menu' stamp: 'LC 3/17/2000 19:53'!
remove
	self privateRemove.
	self modelWakeUp
! !

!MethodModel methodsFor: 'menu' stamp: 'LC 1/28/2000 14:54'!
senders
	Smalltalk browseAllCallsOn: self selector
! !

!MethodModel methodsFor: 'menu' stamp: 'LC 2/16/1999 13:01'!
showBytecodes
	self okToChange ifFalse: [^ self changed: #flash].
	editSelection == #byteCodes
		ifTrue: [editSelection _ nil]
		ifFalse: [editSelection _ #byteCodes].
	self changed: #contents! !

!MethodModel methodsFor: 'private' stamp: 'LC 1/28/2000 14:51'!
changeClass: aClass 
	| classification |
	classification _ self classification.
	methodClass _ aClass.
	self classification: classification.
	self changed: #relabel! !

!MethodModel methodsFor: 'private' stamp: 'fg 8/1/2001 22:29'!
changeClass: aClass copy: aBoolean
	self changeClass: aClass remove: aBoolean not! !

!MethodModel methodsFor: 'private' stamp: 'LC 1/28/2000 14:50'!
changeClass: aClass remove: aBoolean
	| classification |
	classification _ self classification.
	aBoolean ifTrue: [self privateRemove].
	methodClass _ self classField isMeta ifTrue: [aClass class] ifFalse: [aClass].
	self classification: classification.
	self changed: #relabel! !

!MethodModel methodsFor: 'private' stamp: 'LC 5/6/2000 10:00'!
class: aClass selector: aSymbol
	self methodClass: aClass methodSelector: aSymbol.
	contents _ self source! !

!MethodModel methodsFor: 'private' stamp: 'fg 8/1/2001 18:56'!
contents: aString notifying: aController 
	| newSelector |
	editSelection = #showBytecodes ifTrue: [^ false].
	newSelector _ self selectedClassOrMetaClass
		compile: aString asText
		classified: self classification
		notifying: aController.
	newSelector isNil ifTrue: [^ false].
	methodSelector _ newSelector.
	contents _ self source.
	self changed: #relabel.
	^ true! !

!MethodModel methodsFor: 'private' stamp: 'LC 10/4/1998 14:12'!
defaultBackgroundColor
	^ #lightOrange! !

!MethodModel methodsFor: 'private' stamp: 'LC 11/9/1998 23:22'!
messageListIndex
	^ 1! !

!MethodModel methodsFor: 'private' stamp: 'fg 8/6/2001 10:39'!
modelWakeUp
	"When my view gets activated, I must update my contents."
	self updateClass.
	self hasUnacceptedEdits ifTrue: [^ self].
	(contents isEmptyOrNil or: [
	self didCodeChangeElsewhere]) ifFalse: [^ self].
	contents _ self source.
	self changed: #contents.
	self changed: #annotation
! !

!MethodModel methodsFor: 'private' stamp: 'fg 8/4/2001 08:27'!
privateRemove
	| category org |
	category _ self classification.
	self selectedClassOrMetaClass removeSelector: self selector.
	org _ self selectedClass organization.
	(org listAtCategoryNamed: category)
		isEmpty ifTrue: [org removeCategory: category].
	contents _ ''.
	methodSelector _ nil.
! !

!MethodModel methodsFor: 'private' stamp: 'fg 8/1/2001 17:46'!
selectedClass
	^ methodClass isMeta 
		ifTrue: [methodClass soleInstance] 
		ifFalse: [methodClass]
! !

!MethodModel methodsFor: 'private' stamp: 'LC 6/19/1999 20:04'!
selectedClassOrMetaClass
	^ self classField! !

!MethodModel methodsFor: 'private' stamp: 'lc 5/16/1999 17:05'!
selectedMessageCategoryName
	^ self classification! !

!MethodModel methodsFor: 'private' stamp: 'LC 1/28/2000 14:56'!
selectedMessageName
	^ self selector! !

!MethodModel methodsFor: 'private' stamp: 'LC 1/28/2000 14:52'!
updateClass
	| newClassName newClass isMeta tail |
	(methodClass name beginsWith: 'AnObsolete')
		ifTrue: 
			[isMeta _ methodClass isMeta.
			tail _ isMeta
						ifTrue: ["' class' size"
							6]
						ifFalse: [0].
			newClassName _ methodClass name copyFrom: 11 to: methodClass name size - tail.
			newClass _ Smalltalk at: newClassName asSymbol ifAbsent: [].
			(newClass isKindOf: Behavior)
				ifTrue: [methodClass _ isMeta
								ifTrue: [newClass class]
								ifFalse: [newClass]]]! !

!MethodModel methodsFor: 'opening' stamp: 'fg 8/2/2001 15:34'!
annotationsPane
	| aTextMorph |
	aTextMorph _ PluggableTextMorph 
		on: self 
		text: #annotation 
		accept: nil
		readSelection: nil
		menu: #annotationPaneMenu:shifted:.
	aTextMorph
		askBeforeDiscardingEdits: false;
		borderWidth: 0;
		hideScrollBarIndefinitely.
	^ aTextMorph


	
! !

!MethodModel methodsFor: 'opening' stamp: 'fg 8/6/2001 18:25'!
asMorph
	^ self openAsMorph! !

!MethodModel methodsFor: 'opening' stamp: 'fg 7/16/2001 10:07'!
buildMethodMathMorph
	| codePane frame |
	codePane _ MethodMathMorph
				on: self
				text: #contents
				accept: #contents:notifying:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
	codePane borderWidth: 1;
	 color: Color white;
	 scrollBarOnLeft: true;
	 extent: 400 @ 130;
	 activate;
	 retractable: false;
	 name: 'methodPane';
	 yourself.
	frame _ MethodFrameMorph new addMorphBack: codePane.
	frame activate.
	^ frame! !

!MethodModel methodsFor: 'opening' stamp: 'fg 8/1/2001 19:50'!
contentsPane
	^ PluggableTextMorph
		on: self
		text: #contents
		accept: #contents:notifying:
		readSelection: #contentsSelection
		menu: #codePaneMenu:shifted:


	
! !

!MethodModel methodsFor: 'opening' stamp: 'fg 8/4/2001 08:11'!
grabMethod
	World activeHand grabMorph: (TransferMorph withPassenger: self from: self) 

! !

!MethodModel methodsFor: 'opening' stamp: 'fg 7/14/2001 21:05'!
initialExtent
	"Answer the desired extent for the receiver when it is first opened on the screen.  "

	^ 450@185! !

!MethodModel methodsFor: 'opening' stamp: 'fg 7/14/2001 20:42'!
openAsMorph
	^ Preferences methodsInsideSystemWindows
		ifTrue: [self openSystemWindowMorph]
		ifFalse: [self openMethodMathMorph]
! !

!MethodModel methodsFor: 'opening' stamp: 'fg 8/6/2001 17:55'!
openAttachedTo: aHand
	^ self openAsMorph! !

!MethodModel methodsFor: 'opening' stamp: 'fg 7/16/2001 10:08'!
openMethodMathMorph
	World primaryHand attachMorph: self buildMethodMathMorph
! !

!MethodModel methodsFor: 'opening' stamp: 'fg 8/6/2001 15:15'!
openSystemWindowMorph
	(SystemWindow labelled: self labelString)
		model: self;
		addMorph: self contentsPane frame: (0@0 extent: 1@0.85);	
		addMorph: self annotationsPane frame: (0@0.85 extent: 1@0.15);
		extent: self initialExtent;
		openInWorld	
! !

!MethodModel methodsFor: 'printing' stamp: 'fg 7/30/2001 20:13'!
printOn: aStream
	aStream 
		print: methodClass;
		nextPutAll: ' | ';
		print: methodSelector! !

!MethodModel methodsFor: 'morphic wrappers' stamp: 'fg 11/11/1999 12:41'!
hasNiceWrapper
	^ true! !

!MethodModel methodsFor: 'morphic wrappers' stamp: 'fg 8/1/2001 17:46'!
wrappedClass
	^ self selectedClass! !


!MethodModel class methodsFor: 'instance creation' stamp: 'fg 7/30/2001 20:13'!
class: aClass selector: aSymbol
	^ self new class: aClass selector: aSymbol! !


!MorphicWrapper methodsFor: 'accessing' stamp: 'r++ 11/28/1999 23:48'!
arguments
	^ self
		valueOfProperty: #arguments
		ifAbsent: [^ self initializeArguments]! !

!MorphicWrapper methodsFor: 'accessing' stamp: 'r++ 11/28/1999 23:05'!
arguments: anObject
	self setProperty: #arguments toValue: anObject! !

!MorphicWrapper methodsFor: 'accessing' stamp: 'LC 5/12/2000 14:22'!
balloonText
	self updateBalloon.
	^ super balloonText! !

!MorphicWrapper methodsFor: 'accessing' stamp: 'r++ 11/28/1999 23:48'!
initializeArguments
	self arguments: (OrderedCollection new).
	^ self arguments! !

!MorphicWrapper methodsFor: 'accessing' stamp: 'LC 12/11/2000 07:59'!
strings
	^ (self findA: AlignmentMorph) ifNil: [self initializeStrings]! !

!MorphicWrapper methodsFor: 'accessing' stamp: 'r++ 11/27/1999 20:05'!
unlockedMorphsAt: aPoint addTo: mList
	"Return a collection of all morphs in this morph structure that contain the given point, possibly including the receiver itself.
	We don't want to do it recursively so the MorphicWrapper behaves as an single Morph "
	(self fullBounds containsPoint: aPoint) ifFalse: [^ mList].  "quick elimination"
	self isLocked ifTrue: [^ mList].
	(self containsPoint: aPoint) ifTrue: [mList addLast: self].
	^ mList
! !

!MorphicWrapper methodsFor: 'accessing' stamp: 'r++ 2/19/2000 18:54'!
wrapee
	^wrapee! !

!MorphicWrapper methodsFor: 'accessing' stamp: 'LC 6/10/2000 12:23'!
wrapee: anObject 
	wrapee ifNotNil: [wrapee removeDependent: self].
	self privateWrapee: anObject.
	wrapee ifNotNil: [wrapee addDependent: self].
	self updateContents! !

!MorphicWrapper methodsFor: 'event handling' stamp: 'r++ 2/21/2000 00:09'!
acceptBalloon: aCodeBalloon
	self satellitesForever.
	super acceptBalloon: aCodeBalloon.
	self resetSatellites.
! !

!MorphicWrapper methodsFor: 'event handling' stamp: 'LC 11/5/2000 18:34'!
doubleClick: evt 
	self satellitesForever.
	evt hand dropMorph: self event: evt.
	(self doubleClickMenu: evt)
		popUpAt: evt cursorPoint
		forHand: evt hand
		in: evt hand world.
	self deleteBalloon.
! !

!MorphicWrapper methodsFor: 'event handling' stamp: 'r++ 12/9/97 15:24'!
drag: evt
	"len 12/1/97 22:03	I changed #grabMorph: by #attachMorph:. It's an experiment.
	r++ 12/9/97 15:23		I changed it back to #grabMorph: so if you only click on an
						Outliner it's not moved"
	evt hand grabMorph: self! !

!MorphicWrapper methodsFor: 'event handling' stamp: 'LC 11/5/2000 18:12'!
handlesMouseDown: evt
	^ self owner isWorldMorph
! !

!MorphicWrapper methodsFor: 'event handling' stamp: 'r++ 2/21/2000 00:02'!
handlesMouseOver: evt
	^ true! !

!MorphicWrapper methodsFor: 'event handling' stamp: 'LC 12/10/2000 21:30'!
mouseDown: evt 
	evt yellowButtonPressed
		ifTrue: [(self doubleClickMenu: evt)
				popUpAt: evt cursorPoint
				forHand: evt hand
				in: evt hand world.
			^ self].
	self resetSatellites.
	evt hand newKeyboardFocus: evt hand world.
	evt hand waitForClicksOrDrag: self event: evt.
	evt hand grabMorph: self! !

!MorphicWrapper methodsFor: 'event handling' stamp: 'fg 8/4/2001 17:01'!
mouseEnter
	self strings
		submorphsDo: [:each | (each isKindOf: StringMorph)
				ifTrue: [each color: Color red darker]].
	self satellitesForever! !

!MorphicWrapper methodsFor: 'event handling' stamp: 'fg 8/4/2001 17:02'!
mouseEnter: evt
	self mouseEnter! !

!MorphicWrapper methodsFor: 'event handling' stamp: 'r++ 2/21/2000 00:05'!
mouseLeave: evt 
	self strings
		submorphsDo: [:each | (each isKindOf: StringMorph)
				ifTrue: [each color: Color black]].
	self resetSatellites! !

!MorphicWrapper methodsFor: 'satellites' stamp: 'LC 6/17/1999 17:47'!
addSatelliteFor: anObject 
	| satellite |
	self resetSatellites.
	self addMorph: (satellite _ DeferredMessageMorph
					in: 10
					send: #remove:ifAbsent:
					to: self arguments
					withArguments: (Array with: anObject with: [])).
	^ satellite startStepping! !

!MorphicWrapper methodsFor: 'satellites' stamp: 'LC 6/17/1999 17:56'!
removeSatellites
	self
		submorphsDo: [:each | (each isKindOf: SatelliteMorph)
				ifTrue: [each stop]]! !

!MorphicWrapper methodsFor: 'satellites' stamp: 'LC 6/17/1999 16:53'!
resetSatellites
	^ self satellites do: [:each | each reset]! !

!MorphicWrapper methodsFor: 'satellites' stamp: 'LC 6/17/1999 16:53'!
satellites
	^ self submorphs select: [:each | each isKindOf: SatelliteMorph]! !

!MorphicWrapper methodsFor: 'satellites' stamp: 'LC 6/17/1999 18:10'!
satellitesForever
	^ self satellites do: [:each | each deferForever]! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'LC 6/17/1999 17:47'!
addArgument: anObject 
	self arguments add: anObject.
	self addSatelliteFor: anObject! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/28/1999 23:13'!
moreSelectors
	"Answser if there are selectors with more than (self arguments size) arguments."
	^ (self wrapeeSelectorsForArguments: self arguments size + 1) isEmpty not! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'r++ 2/19/2000 19:16'!
receiver
	^ self wrapee! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/28/1999 23:27'!
wrapeeCategorizedSelectors: aCollection
	| dict answer category |
	dict _ Dictionary new.
	aCollection do: [ :each |
		category _ self wrapeeCategoryAt: each.
		(dict at: category ifAbsent: [dict at: category put: OrderedCollection new]) add: each].
	answer _ SortedCollection sortBlock: [ :a :b | a key <= b key].
	dict associationsDo: [ :each | answer add: each].
	^ answer! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/28/1999 23:27'!
wrapeeCategoryAt: aSymbol
	| class |
	class _ self wrapeeClass.
	[class includesSelector: aSymbol] whileFalse: [class _ class superclass].
	^ class whichCategoryIncludesSelector: aSymbol! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/28/1999 23:14'!
wrapeeClass
	^ self wrapee class! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/28/1999 23:26'!
wrapeeInstVarAt: anInteger event: evt
	evt hand isNil ifFalse: [evt hand attachMorph: ((self wrapee instVarAt: anInteger) asMorph); shake]! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/28/1999 23:26'!
wrapeeInstVarAt: anInteger put: anObject
	self wrapee instVarAt: anInteger put: anObject.
	self resetSatellites.
	self updateContents! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/28/1999 23:28'!
wrapeeInstVarNames
	^ self wrapeeClass allInstVarNames! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'LC 5/12/2000 14:24'!
wrapeeNames
	^ (self world ifNil: [^ #()]) namesFor: self wrapee! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/28/1999 23:26'!
wrapeePerform: aSymbol event: evt 
	| result args |
	args _ self arguments asArray.
	self satellitesForever.
	result _ evt shiftPressed
				ifTrue: [self wrapee halt perform: aSymbol withArguments: args]
				ifFalse: [self wrapee perform: aSymbol withArguments: args].
	self wrapee == result
		ifTrue: [self shake]
		ifFalse: [evt hand isNil
				ifFalse: 
					[result asMorph runAndAttachTo: evt hand]].
	self resetSatellites.
	self updateContents! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/28/1999 23:12'!
wrapeeSelectorsForArguments: args
	| class answer |
	class _ self wrapeeClass.
	answer _ Set new.
	[class selectorsDo: [ :each | each numArgs = args "size" ifTrue: [answer add: each]].
		(class _ class superclass) == Object or: [class isNil]] whileFalse.
	^ answer! !

!MorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/28/1999 23:25'!
wrapeeSubparts
	| subparts |
	subparts _ Set new.
	1 to: self wrapeeClass instSize do: [ :each | subparts add: (self wrapee instVarAt: each) asMorph].
	1 to: self wrapee basicSize do: [ :each | subparts add: (self wrapee basicAt: each) asMorph].
	^ subparts! !

!MorphicWrapper methodsFor: 'dropping/grabbing' stamp: 'r++ 2/21/2000 00:37'!
acceptDroppingCode: aMorph event: evt
	self acceptBalloon: aMorph! !

!MorphicWrapper methodsFor: 'dropping/grabbing' stamp: 'LC 5/14/2000 08:54'!
acceptDroppingMorph: aMorph event: evt 
	"What to do when something is droppend: Show a menu 
	
	r++ 11/27/97 16:00 
	
		added #droppingMenu:event: so subclasses can add their own options to 
	droppingMenu 
	len 12/1/97 21:14 
	
		I changed this after adding the dropping-code scheme. 
	
	len 5/14/1998 15:41 
	
		Fixed a bug. Now it works fine. 
	
	r++ 6/17/1998 14:08 
	
		Changed arguments scheme: aMorph is added to arguments inmediatly 
	after deletion so it can be recovered with forget arguments"
	| |
	aMorph delete.
	(aMorph isKindOf: CodeBalloonMorph)
		ifTrue: [^ self acceptDroppingCode: aMorph event: evt].
	self addArgument: (aMorph isMorphicWrapper
			ifTrue: [aMorph wrapee]
			ifFalse: [aMorph]).
"
	menu _ self menuForDropping: aMorph event: evt.
	menu position: evt hand position.
	self world addMorph: menu
"
! !

!MorphicWrapper methodsFor: 'dropping/grabbing' stamp: 'fg 8/6/2001 18:41'!
justDroppedInto: aMorph event: anEvent
	super justDroppedInto: aMorph event: anEvent.
	aMorph isWorldMorph ifTrue: [self mouseEnter: anEvent].! !

!MorphicWrapper methodsFor: 'dropping/grabbing' stamp: 'LC 7/7/1999 12:25'!
wantsDroppedMorph: aMorph event: evt
	"len 12/2/97 01:29	I changed this to allow code dropping.
						See acceptDroppingMorph:event:".
	(aMorph isKindOf: SystemWindow) ifTrue: [^ false].
	^ (aMorph isKindOf: CodeBalloonMorph)
		or: [self moreSelectors]! !

!MorphicWrapper methodsFor: 'private' stamp: 'r++ 2/19/2000 18:54'!
privateWrapee: anObject
	wrapee _ anObject! !

!MorphicWrapper methodsFor: 'initializing' stamp: 'fg 8/4/2001 12:29'!
initialize
	super initialize.
	self color: Color transparent.
	self extent: 40@20.

! !

!MorphicWrapper methodsFor: 'initializing' stamp: 'DAB 1/11/2001 13:33'!
initializeStrings
	| answer |
	self addMorph: ((answer _ AlignmentMorph new) lock listDirection: #topToBottom;
			 color: self color;
			 layoutInset: 0;
			 hResizing: #shrinkWrap;
			 vResizing: #shrinkWrap).
	^ answer! !

!MorphicWrapper methodsFor: 'copying / deleting' stamp: 'r++ 11/27/1999 19:23'!
copy
	"Answer a copy of the receiver."

	^ super copy privateWrapee: self wrapee copy! !

!MorphicWrapper methodsFor: 'copying / deleting' stamp: 'LC 6/10/2000 12:14'!
delete
	self wrapee removeDependent: self.
	^ super delete.! !

!MorphicWrapper methodsFor: 'menu' stamp: 'len 5/13/1998 13:07'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"r++ 12/5/97 14:43
		added inspect object option"
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu
		addLine;
		add: 'spawn subparts' action: #spawnSubparts;
		add: 'inspect object' action: #inspectObject! !

!MorphicWrapper methodsFor: 'menu' stamp: 'r++ 11/28/1999 23:25'!
addSelectorsMenuItemsTo: aMenu event: evt
	| selectors submenu |
	(selectors _ self wrapeeSelectorsForArguments: self arguments size "added") isEmpty ifTrue: [^false].
	aMenu addLine.

	self arguments size == 0 
		ifTrue: [
			(self wrapeeCategorizedSelectors: selectors) do: [ :assoc |
				submenu _ MenuMorph new.
				assoc value do: [ :each |
					submenu add: each
						target: self
						selector: #wrapeePerform:event:
						argumentList: (Array with: each with: evt)].
				aMenu add: assoc key subMenu: submenu]]
		ifFalse: [
			(self wrapeeCategorizedSelectors: selectors) do: [ :assoc |
				submenu _ MenuMorph new.
				assoc value do: [ :each |
					submenu add: ((((each keywords) with: self arguments collect: [:keyword :argument | keyword, ' ', (argument printString truncateWithElipsisTo: 10), ' '] ) inject: '' into: [:tot :argString | tot, argString] ) withBlanksTrimmed)
						target: self
						selector: #wrapeePerform:event:
						argumentList: (Array with: each with: evt)].
				aMenu add: assoc key subMenu: submenu]].
	^ true.! !

!MorphicWrapper methodsFor: 'menu' stamp: 'r++ 11/28/1999 23:29'!
addVariablesMenuTo: aMenu event: evt
	| variables submenu |
	submenu _ MenuMorph new.
	variables _ self wrapeeInstVarNames.
	1 to: variables size do: [ :each |
		submenu add: (variables at: each)
			target: self
			selector: #wrapeeInstVarAt:event:
			argumentList: (Array with: each with: evt)].
	variables size > 0 ifTrue: [aMenu add: 'instance variables' subMenu: submenu].
	^ variables size > 0! !

!MorphicWrapper methodsFor: 'menu' stamp: 'r++ 2/19/2000 20:05'!
addWrappersMenuTo: aMenu
	| submenu |
	submenu _ MenuMorph new.
	(MorphicWrapper withAllSubclasses asSortedCollection: [:a :b | a name < b name]) do:
		[:each |
		(each canWrap: self wrapee) ifTrue:
			[submenu
	
			add: each name,(self class == each ifTrue: [' -:'] ifFalse: [''])
	
			target: self
	
			selector: #beWrapperType:
	
			argumentList: (Array with: each)]].
	submenu submorphs isEmpty ifFalse: [
	
	aMenu add: 'change wrapper' subMenu: submenu]! !

!MorphicWrapper methodsFor: 'menu' stamp: 'r++ 2/19/2000 21:18'!
beWrapperType: aMWSubclass
	"This method causes a MW to delete itself, and rewrap it's object with some other kind of wrapper.
DVF 10/9/1998 22:01
	created. Not sure if it does all housecleaning required. The deletion of the current wrapper seems slow."

	| morph |
	self forgetArguments.
	self wrapee removeDependent: self.
	morph _ aMWSubclass on: self wrapee.
	self world addMorph: morph.
	morph position: self position.
	self world activeHand attachMorph: morph.
	self delete.
"
	morph owner shake."! !

!MorphicWrapper methodsFor: 'menu' stamp: 'LC 6/17/1999 18:26'!
doubleClickMenu: evt 
	| menu |
	menu _ MenuMorph new.
	(self addSelectorsMenuItemsTo: menu event: evt)
		ifTrue: [menu addLine].
	self addVariablesMenuTo: menu event: evt.
	self arguments isEmpty ifFalse: [menu addLine;
			add: 'forget arguments'
			target: self
			selector: #forgetArguments].
	self addWrappersMenuTo: menu.
	^ menu! !

!MorphicWrapper methodsFor: 'menu' stamp: 'LC 6/17/1999 17:56'!
forgetArguments
	"Called when user wants to forget previously saved 
	arguments. This must forget arguments after adding 
	them to the world, because they had been removed before 
	saving them."
	self removeSatellites.
	self surroundedBy: self arguments.
	self initializeArguments! !

!MorphicWrapper methodsFor: 'menu' stamp: 'r++ 11/28/1999 23:59'!
spawnSubparts
	" add my object's subparts to the world located around myself"
	^ self surroundedBy: self wrapeeSubparts.! !

!MorphicWrapper methodsFor: 'menu' stamp: 'len 10/2/1998 03:07'!
surroundedBy: aCollection
	"Locate elements of aCollection around me in my world."
	| angle iteration morph |
	self isInWorld ifFalse: [^ self].
	aCollection isEmpty ifTrue: [^ self].
	iteration _ 0.
	aCollection do: [ :each |
		angle _ Float pi * 2.0 / aCollection size * iteration.
		(morph _ each asMorph) position: angle cos * self width @ (angle sin * self height) + self center - (morph extent // 2).
		self world addMorph: morph.
		morph shake.
		iteration _ iteration + 1]! !

!MorphicWrapper methodsFor: 'updating' stamp: 'r++ 11/29/1999 00:50'!
update: what
	^ self wrapee == what ifTrue: [self updateContents; updateBalloon].
! !

!MorphicWrapper methodsFor: 'updating' stamp: 'r++ 11/29/1999 00:50'!
updateBalloon
	| names text |
	(names _ self wrapeeNames) isEmpty
		ifTrue: 
			[self setBalloonText: 'I am ' , ((self wrapeeClass name at: 1) isVowel
						ifTrue: ['an ']
						ifFalse: ['a ']) , self wrapeeClass name.
			^ self].
	text _ 'I am ' , names first , ', the ' , self wrapeeClass name.
	names size > 1
		ifTrue: 
			[text _ text , ' (a.k.a. ' , names second.
			3 to: names size do: [:each | text _ text , ', ' , (names at: each)].
			text _ text , ')'].
	self setBalloonText: text! !

!MorphicWrapper methodsFor: 'updating' stamp: 'r++ 11/28/1999 22:02'!
updateContents
	| strings stream | 
	strings _ self strings ifNil: [self initialize.
		^ self updateContents].
	stream _ ReadStream on: self wrapee printString.
	strings removeAllMorphs.
	[stream atEnd] whileFalse: [
		strings addMorphBack: (StringMorph new
			contents: stream nextLine;
			font: (TextStyle default fontAt: 3))].
	self bounds: strings fullBounds.
	self changed.
! !

!MorphicWrapper methodsFor: 'testing' stamp: 'LC 5/14/2000 08:52'!
isMorphicWrapper
	^ true! !

!MorphicWrapper methodsFor: 'printing' stamp: 'LC 5/15/2000 10:42'!
name
	| names |
	^ (names _ self wrapeeNames) isEmpty
		ifTrue: [wrapee name]
		ifFalse: [names first] ! !

!MorphicWrapper methodsFor: 'printing' stamp: 'r++ 11/27/1999 20:26'!
printOn: aStream
	self class name printOn: aStream.
	aStream nextPut: $(.
	self wrapee printOn: aStream.
	aStream nextPut: $).! !

!MorphicWrapper methodsFor: 'morphic wrappers' stamp: 'fg 8/6/2001 18:18'!
attachedToHand: aHandMorph
	aHandMorph attachMorph: self withDelta: self bounds extent // 8! !


!BitmappedMorphicWrapper methodsFor: 'dropping/grabbing' stamp: 'LC 11/9/1998 16:18'!
acceptDroppingMorph: aMorph event: evt
	^ ((aMorph isKindOf: ImageMorph) or: [aMorph isKindOf: SketchMorph])
		ifTrue:
			[image _ aMorph.
			self updateContents]
		ifFalse: [super acceptDroppingMorph: aMorph event: evt]! !

!BitmappedMorphicWrapper methodsFor: 'dropping/grabbing' stamp: 'LC 11/9/1998 16:17'!
wantsDroppedMorph: aMorph event: evt
	^ ((super wantsDroppedMorph: aMorph event: evt)
		or: [aMorph isKindOf: ImageMorph])
		or: [aMorph isKindOf: SketchMorph]
! !

!BitmappedMorphicWrapper methodsFor: 'initialization' stamp: 'LC 11/18/1998 19:19'!
initialize
	super initialize.
	image ifNil: [image _ SketchMorph new]! !

!BitmappedMorphicWrapper methodsFor: 'initialization' stamp: 'r++ 2/19/2000 22:31'!
object: anObject 
	| form ext name | self halt.
	name _ anObject class name.
	form _ ImageImports at: name ifAbsent: [].
	form isNil
		ifTrue: 
			[ext _ #('.bmp' '.gif' '.jpg' '.pcx' )
				detect: [:one | FileStream isAFileNamed: name , one]
				ifNone: [].
			ext notNil ifTrue: [form _ Form fromFileNamed: name , ext]].
	form notNil
		ifTrue: 
			[ImageImports at: name put: form.
			self image: (ImageMorph new image: form)].
	^ super object: anObject! !

!BitmappedMorphicWrapper methodsFor: 'initialization' stamp: 'r++ 2/19/2000 22:33'!
wrapee: anObject 
	| form ext name | self halt.
	name _ anObject class name.
	form _ ImageImports at: name ifAbsent: [].
	form isNil
		ifTrue: 
			[ext _ #('.bmp' '.gif' '.jpg' '.pcx' )
				detect: [:one | FileStream isAFileNamed: name , one]
				ifNone: [].
			ext notNil ifTrue: [form _ Form fromFileNamed: name , ext]].
	form notNil
		ifTrue: 
			[ImageImports at: name put: form.
			self image: (ImageMorph new image: form)].
	^ super wrapee: anObject! !

!BitmappedMorphicWrapper methodsFor: 'menu' stamp: 'LC 11/9/1998 16:25'!
doubleClickMenu: evt
	| menu selector label |
	menu _ super doubleClickMenu: evt.
	(image isKindOf: ImageMorph)
		ifTrue:
			[label _ 'grab from screen'.
			selector _ #grabFromScreen]
		ifFalse:
			[(image isKindOf: SketchMorph)
				ifTrue:
					[label _ 'repaint'.
					selector _ #editDrawing]
				ifFalse: [^ menu]].
	menu
		addLine;
		add: label
		target: image
		selector: selector.
	^ menu! !

!BitmappedMorphicWrapper methodsFor: 'updating' stamp: 'r++ 2/19/2000 20:55'!
updateContents
	super updateContents.
	self strings centering: #center.
	self strings addMorph: image.
	self bounds: self fullBounds! !

!BitmappedMorphicWrapper methodsFor: 'accessing' stamp: 'LC 11/18/1998 18:29'!
image: anImage
	image _ anImage.
	self updateContents! !


!ClassMorphicWrapper methodsFor: 'updating' stamp: 'r++ 2/19/2000 19:37'!
addLine
     (submorphs isEmpty or: [self strings submorphs isEmpty]) ifTrue: [^ self].
    (self strings lastSubmorph isKindOf: MenuLineMorph)
        ifFalse: [self strings addMorphBack: MenuLineMorph new].
! !

!ClassMorphicWrapper methodsFor: 'updating' stamp: 'LC 2/29/2000 16:39'!
removeClassVar: varName 
	wrapee removeClassVarName: varName.
	Smalltalk logChange: wrapee name , ' removeClassVarName: ' , varName printString.
	self updateContents! !

!ClassMorphicWrapper methodsFor: 'updating' stamp: 'LC 2/29/2000 16:39'!
removeInstVar: varName 
	wrapee removeInstVarName: varName.
	Smalltalk logChange: wrapee name , ' removeInstVarName: ' , varName printString.
	self updateContents! !

!ClassMorphicWrapper methodsFor: 'updating' stamp: 'LC 2/29/2000 17:29'!
removePool: aDictionary 
	wrapee removeSharedPool: aDictionary.
	Smalltalk logChange: wrapee name , ' removeSharedPool: ' , (Smalltalk keyAtIdentityValue: aDictionary).
	self updateContents! !

!ClassMorphicWrapper methodsFor: 'updating' stamp: 'LC 9/15/1998 11:01'!
updateBalloon
	| names text |
	(names _ self names) isEmpty
		ifTrue: [self setBalloonText: 'I am the ', wrapee class name.
				^ self].
	text _ 'I am ', names first, ', the ', self wrapee class name.
	names size > 1
		ifTrue: [text _ text, ' (a.k.a. ', names second.
				3 to: names size do: [ :each | text _ text, ', ', (names at: each)].
				text _ text, ')'].
	self setBalloonText: text! !

!ClassMorphicWrapper methodsFor: 'updating' stamp: 'fg 8/10/2001 16:01'!
updateContents
	| title font |
	self updateWrapee.
	self strings removeAllMorphs.
	Preferences smallClassMorphicWrappers 
		ifFalse: 
			[font _ TextStyle default fontAt: 1.
			wrapee instVarNames do: [:each |
				self strings addMorphBack: (StringMorph new contents: each; font: font)].
			"
			self addLine.
			wrapee classVarNames do: [:each |
				self strings addMorphBack: (StringMorph new contents: each; font: font)].
			self addLine.
			wrapee sharedPools do: [:each |
				self strings addMorphBack: (StringMorph new contents: (Smalltalk keyAtValue: each);
					 font: font)].
			
			self addLine.
			self strings addMorphBack: (StringMorph new contents: wrapee category;
				 font: font)
			"].
	title _ self titleButton.
	self strings addMorph: title.
	self bounds: self fullBounds! !

!ClassMorphicWrapper methodsFor: 'updating' stamp: 'LC 2/29/2000 06:54'!
updateWrapee
	| oldName newName newWrapee |
	oldName _ wrapee name.
	(oldName beginsWith: 'AnObsolete')
		ifTrue: 
			[newName _ oldName copyFrom: 11 to: oldName size.
			newWrapee _ Smalltalk at: newName asSymbol ifAbsent: [].
			newWrapee notNil ifTrue: [self wrapee: newWrapee]]! !

!ClassMorphicWrapper methodsFor: 'initialization' stamp: 'LC 9/15/1998 01:10'!
defaultColor
	^ Color r: 0.599 g: 0.8 b: 1.0! !

!ClassMorphicWrapper methodsFor: 'initialization' stamp: 'fg 8/2/2001 15:01'!
initialize
	| inset border |
	super initialize.
	color _ self defaultColor.
	Preferences smallClassMorphicWrappers 
		ifTrue: [inset _ 2. border _ 1]
		ifFalse: [inset _ 4. border _ 3].
	self strings 
		layoutInset: inset;
		color: self defaultColor;
		borderWidth: border;
		borderColor: #raised! !

!ClassMorphicWrapper methodsFor: 'testing' stamp: 'LC 5/14/2000 08:53'!
isDroppedClass: aMorph 
	^ aMorph isMorphicWrapper and: [aMorph wrapee isBehavior]! !

!ClassMorphicWrapper methodsFor: 'testing' stamp: 'fg 8/1/2001 22:05'!
isDroppedMethod: aMorph
	^ (aMorph isKindOf: TransferMorph)
	and: [aMorph passenger isKindOf: MethodModel]
! !

!ClassMorphicWrapper methodsFor: 'testing' stamp: 'LC 5/14/2000 08:53'!
isDroppedVariable: aMorph 
	^ aMorph isMorphicWrapper and: [aMorph wrapee isKindOf: String]! !

!ClassMorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/21/1998 19:43'!
classCategoryAt: aSymbol
	| class |
	class _ self wrapeeClass class.
	[class includesSelector: aSymbol] whileFalse: [class _ class superclass].
	^ class whichCategoryIncludesSelector: aSymbol! !

!ClassMorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/21/1998 18:54'!
classSelectors
	^ self wrapeeClass class selectors asSortedCollection! !

!ClassMorphicWrapper methodsFor: 'delegation' stamp: 'fg 7/14/2001 20:54'!
editCodeFor: aClass selector: aSymbol event: evt
	(MethodModel class: aClass selector: aSymbol) openAsMorph.
	self updateContents

! !

!ClassMorphicWrapper methodsFor: 'delegation' stamp: 'LC 10/9/1998 09:37'!
instanceSelectors
	^ wrapee selectors asSortedCollection! !

!ClassMorphicWrapper methodsFor: 'delegation' stamp: 'LC 1/28/2000 06:41'!
oldEditCodeFor: aClass selector: aSymbol event: evt
	"This is a demonstration"
	| model morph |
	model _ MethodModel class: aClass selector: aSymbol.
	morph _ model openAsMorph.
	evt hand isNil ifFalse: [evt hand attachMorph: morph].
	morph activate.
	self updateContents

! !

!ClassMorphicWrapper methodsFor: 'delegation' stamp: 'LC 10/26/1998 00:13'!
showSubclasses
	| answer morphs |
	answer _ wrapee subclasses.
	morphs _ answer collect: [:each | each asMorph].
	^ self surroundedBy: morphs
! !

!ClassMorphicWrapper methodsFor: 'delegation' stamp: 'LC 10/6/1998 13:19'!
showSuperclass: evt
	| answer morph |
	answer _ wrapee superclass.
	morph _ answer asMorph.
	evt hand isNil ifFalse: [evt hand attachMorph: morph].
	self updateContents! !

!ClassMorphicWrapper methodsFor: 'delegation' stamp: 'LC 9/17/1998 01:20'!
wrapeeCategorizedClassSelectors: aCollection
	| dict answer category |
	dict _ Dictionary new.
	aCollection do:
		[:each |
		category _ self classCategoryAt: each.
		(dict at: category ifAbsent: [dict at: category put: OrderedCollection new]) add: each].
	answer _ SortedCollection sortBlock: [:a :b | a key <= b key].
	dict associationsDo: [:each | answer add: each].
	^ answer! !

!ClassMorphicWrapper methodsFor: 'delegation' stamp: 'r++ 11/21/1998 18:51'!
wrapeeClass
	^ wrapee! !

!ClassMorphicWrapper methodsFor: 'private' stamp: 'LC 5/19/1999 10:05'!
newCategory
	RequestBoxMorph
		request: 'New category for ' , self wrapeeClass name
		respondTo: self
		selector: #setClassCategoryTo:! !

!ClassMorphicWrapper methodsFor: 'private' stamp: 'LC 2/29/2000 07:03'!
setClassCategoryTo: aCategory 
	self wrapeeClass category: aCategory.
	Smalltalk logChange: self wrapeeClass name , ' category: ' , aCategory printString.
	self updateContents! !

!ClassMorphicWrapper methodsFor: 'private' stamp: 'r++ 11/21/1998 19:33'!
titleButton
	^ AlignmentMorph new
		color: (Color r: 1.0 g: 0.8 b: 0.4);
		borderWidth: 1;
		borderColor: #inset;
		addMorph:
			(StringMorph
				contents: self wrapee name
				font: (StrikeFont familyName: 'DefaultTextStyle' size: 18));
		yourself
! !

!ClassMorphicWrapper methodsFor: 'menu' stamp: 'r++ 11/23/1998 14:11'!
addVariablesMenuTo: aMenu event: evt
	| submenu |
	submenu _ MenuMorph new.
	wrapee instVarNames do:
		[:each |
		submenu
			add: each asString
			target: self
			selector: #removeInstVar:
			argumentList: (Array with: each)].
	wrapee classVarNames size > 0 ifTrue: [submenu addLine].
	wrapee classVarNames do:
		[:each |
		submenu
			add: each asString
			target: self
			selector: #removeClassVar:
			argumentList: (Array with: each)].
	wrapee sharedPools size > 0 ifTrue: [submenu addLine].
	wrapee sharedPools do:
		[:each |
		submenu
			add: (Smalltalk keyAtValue: each) asString
			target: self
			selector: #removePool:
			argumentList: (Array with: each)].
	submenu items size > 0 ifTrue: [aMenu add: 'remove variable' subMenu: submenu].! !

!ClassMorphicWrapper methodsFor: 'menu' stamp: 'LC 7/7/1999 12:03'!
classCategoryMenu
	| menu dict current append submenu currentGroup group catName |
	dict _ Dictionary new.
	current _ self wrapeeClass category.
	currentGroup _ current copyUpTo: $-.
	SystemOrganization categories do: 
		[:cat | 
		group _ cat copyUpTo: $-.
		group = currentGroup ifTrue: [group _ group , ' -:'].
		append _ cat = current
					ifTrue: [' -:']
					ifFalse: [''].
		(dict at: group ifAbsentPut: [SortedCollection new])
			add: cat , append].
	menu _ MenuMorph new.
	menu
		add: 'add a new category'
		target: self
		selector: #newCategory.
	menu addLine.
	dict keys asSortedCollection do: 
		[:each | 
		submenu _ MenuMorph new.
		(dict at: each)
			do: 
				[:cat | 
				catName _ (cat findString: ' -:')
							= (cat size - 1)
							ifTrue: [cat copyFrom: 1 to: cat size - 3]
							ifFalse: [cat].
				submenu
					add: cat
					target: self
					selector: #setClassCategoryTo:
					argument: catName].
		menu add: each subMenu: submenu].
	^ menu! !

!ClassMorphicWrapper methodsFor: 'menu' stamp: 'LC 7/7/1999 12:08'!
doubleClickMenu: evt 
	| selectors menu submenu |
	{self wrapeeClass. self wrapeeClass class} do: [:class | class removeSelector: #DoIt;
		 removeSelector: #DoItIn:].
	menu _ MenuMorph new.
	(selectors _ self instanceSelectors) isEmpty ifFalse: [(self wrapeeCategorizedSelectors: selectors)
			do: 
				[:assoc | 
				submenu _ MenuMorph new.
				assoc value do: [:each | submenu
						add: each
						target: self
						selector: #editCodeFor:selector:event:
						argumentList: (Array
								with: wrapee
								with: each
								with: evt)].
				menu add: assoc key subMenu: submenu]].
	(selectors _ self classSelectors) isEmpty
		ifFalse: 
			[menu items isEmpty ifFalse: [menu addLine].
			(self wrapeeCategorizedClassSelectors: selectors)
				do: 
					[:assoc | 
					submenu _ MenuMorph new.
					assoc value do: [:each | submenu
							add: each
							target: self
							selector: #editCodeFor:selector:event:
							argumentList: (Array
									with: wrapee class
									with: each
									with: evt)].
					menu add: assoc key subMenu: submenu]].
	menu items isEmpty ifFalse: [menu addLine].
	menu
		add: 'add instance method'
		target: self
		selector: #editCodeFor:selector:event:
		argumentList: (Array
				with: wrapee
				with: nil
				with: evt);
	
		add: 'add class method'
		target: self
		selector: #editCodeFor:selector:event:
		argumentList: (Array
				with: wrapee class
				with: nil
				with: evt).
	self addVariablesMenuTo: menu event: evt.
	menu addLine.
	(self wrapee == Object or: [self wrapee == Morph])
		ifFalse:
			[menu
				addLine;
				add: 'remove this class...'
				target: self
				selector: #removeClass:
				argument: evt].
	menu
		add: 'class category'
		subMenu: self classCategoryMenu;
		addLine;
		add: 'superclass'
		target: self
		selector: #showSuperclass:
		argumentList: (Array with: evt).
	((Array with: Object with: Morph)
		includes: wrapee)
		ifFalse: [menu
				add: 'subclasses'
				target: self
				selector: #showSubclasses].
	menu
		add: 'new subclass'
		target: self
		selector: #subclass;
		addLine.
	self addWrappersMenuTo: menu.
	^ menu! !

!ClassMorphicWrapper methodsFor: 'menu' stamp: 'LC 7/7/1999 13:02'!
removeClass: evt 
	| confirm |
	confirm _ 'Please confirm
Delete ' , self wrapee name , '?'.
	(self confirm: confirm at: evt hand cursorPoint)
		ifTrue: 
			[self wrapee removeFromSystem.
			self delete]! !

!ClassMorphicWrapper methodsFor: 'dropping/grabbing' stamp: 'LC 11/23/1998 12:21'!
acceptDroppingClass: aMorph event: evt 
	"Change the superclass of aMorph wrapee to be my wrapee."
	| subclass superclass inherited instVars classVars newClass |
	subclass _ aMorph wrapeeClass.
	superclass _ self wrapeeClass.
	inherited _ superclass allInstVarNames.
	instVars _ subclass instVarNames reject: [:var | inherited includes: var].
	inherited _ superclass allClassVarNames.
	classVars _ subclass classVarNames reject: [:var | inherited includes: var].
	newClass _ self wrapeeClass
		subclass: aMorph wrapeeClass name asSymbol
		instanceVariableNames:
			(instVars inject: '' into: [:result :var | result , var , ' '])
		classVariableNames:
			(classVars inject: '' into: [:result :var | result , var , ' '])
		poolDictionaries:
			(subclass sharedPools
				inject: ''
				into: [:result :pool | result , (Smalltalk keyAtValue: pool) , ' '])
		category: subclass category asString.
	aMorph wrapee: newClass.
	self surroundedBy: (Array with: aMorph).
	aMorph updateContents! !

!ClassMorphicWrapper methodsFor: 'dropping/grabbing' stamp: 'fg 8/4/2001 11:34'!
acceptDroppingMethod: aTransferMorph event: evt 
	| droppedMethod newMethod |
	droppedMethod _ aTransferMorph passenger.
	self wrapee 
		compile: droppedMethod contents asString 
		classified: droppedMethod classification.
	newMethod _ MethodModel class: wrapee selector: droppedMethod selector.
	"
	Sensor controlKeyPressed
		ifTrue: [droppedMethod privateRemove].
	"
	self shake.
	newMethod asMorph


! !

!ClassMorphicWrapper methodsFor: 'dropping/grabbing' stamp: 'LC 11/23/1998 11:33'!
acceptDroppingMorph: aMorph event: evt 
	(self isDroppedMethod: aMorph)
		ifTrue: [^ self acceptDroppingMethod: aMorph event: evt].
	(self isDroppedVariable: aMorph)
		ifTrue: [^ self acceptDroppingVariable: aMorph event: evt].
	(self isDroppedClass: aMorph)
		ifTrue: [^ self acceptDroppingClass: aMorph event: evt].
		^ super acceptDroppingMorph: aMorph event: evt! !

!ClassMorphicWrapper methodsFor: 'dropping/grabbing' stamp: 'LC 2/29/2000 14:21'!
acceptDroppingVariable: aMorph event: evt 
	| variable category dict |
	aMorph delete.
	self shake.
	category _ self wrapee category.
	variable _ aMorph wrapee.
	variable first isLowercase
		ifTrue: [wrapee addInstVarName: variable]
		ifFalse: [((Smalltalk includesKey: variable asSymbol)
				and: [(dict _ Smalltalk at: variable asSymbol) isKindOf: Dictionary])
				ifTrue: [wrapee addSharedPool: dict]
				ifFalse: [((variable indexOf: $-)
						> 0 or: [SystemOrganization categories includes: variable asSymbol])
						ifTrue: [category _ variable]
						ifFalse: [wrapee addClassVarName: variable]]].
	self wrapee category: category asString.
	Smalltalk logChange: wrapee definition.
	self updateContents! !

!ClassMorphicWrapper methodsFor: 'dropping/grabbing' stamp: 'fg 8/2/2001 00:47'!
wantsDroppedMorph: aMorph event: evt 
	(self isDroppedMethod: aMorph)
		ifTrue: [^ true].
	Sensor shiftPressed
		ifFalse: [^ false].
	(self isDroppedClass: aMorph)
		ifTrue: [^ true].
	(self isDroppedVariable: aMorph)
		ifTrue: [^ true].
	^ false! !

!ClassMorphicWrapper methodsFor: 'compiling' stamp: 'LC 11/19/1998 17:01'!
subclass
	RequestBoxMorph
		request: wrapee name, ' subclass name?'
		respondTo: self
		selector: #subclass:! !

!ClassMorphicWrapper methodsFor: 'compiling' stamp: 'LC 5/7/2000 07:31'!
subclass: aString 
	| s |
	(aString isKindOf: String)
		ifFalse: [^ nil].
	s _ aString withBlanksTrimmed.
	s size > 0 ifFalse: [^ nil].
	^ wrapee subclass: s! !


!MorphicWrapper class methodsFor: 'instance creation' stamp: 'r++ 2/19/2000 20:04'!
canWrap: anObject
	^ true! !

!MorphicWrapper class methodsFor: 'instance creation' stamp: 'r++ 11/21/1998 20:43'!
includeInNewMorphMenu
	^ false! !

!MorphicWrapper class methodsFor: 'instance creation' stamp: 'LC 5/15/2000 13:59'!
on: anObject 
	^ self existingWrapperFor: anObject ifNone: [self new wrapee: anObject]! !

!MorphicWrapper class methodsFor: 'accessing' stamp: 'LC 5/15/2000 11:03'!
existingWrapperFor: anObject ifNone: aBlock
	"Note that with this implementation there is, at most,
	one MW for each object in the whole system. The
	exception is nil, since there may be one MW for it in
	each World."
	^ anObject ifNil: [World
			findDeepSubmorphThat: [:m | m isMorphicWrapper and: [m wrapee isNil]]
			ifAbsent: aBlock]
		ifNotNil: [anObject dependents detect: [:each | each isMorphicWrapper]
				ifNone: aBlock]! !

!MorphicWrapper class methodsFor: 'accessing' stamp: 'r++ 2/19/2000 20:29'!
forgetWrapper: aMorphicWrapper
	^ self wrapee removeDependent: aMorphicWrapper! !

!MorphicWrapper class methodsFor: 'documentation' stamp: 'fg 11/28/2001 10:38'!
fgVersions
"

[fg 7/16/2001 15:10] Primera Version
	- ObjecExplorer integration 

[fg 8/1/2001 02:01] Segunda Version
	- drag and drop
	- PluggableList se inicializa con enableDragNDrop

[fg 8/2/2001 10:21] version incompleta
	- trabajando en el querySymbol:
	- arregle el drag and drop de MethodModels sobre las clases
	- cambios esteticos de MethodModel
	- falta ver como hacer para que el annotationsPane del MethodModel no sea proporcional sino fijo (como un status bar). (poner halt en MessageSet inMorphicWindowLabeled: labelString y ver #addLowerPanesTo:at:with:). Hay que usar un Layout
	- achique ClassMorphicWrappers con una preferencia

Comenzada [fg 8/3/2001 17:21]
- agregue el metodo #aerialKeystroke para darle una chance a los morphs a derivar el mensaje a otro objeto.
- falta arreglar el segundo menu del code pane de los MethodModels



[Detalles]

- MW-addOns
	- Aqui no toque nada

- MW-changesToBase
	- Elimine del changeset el metodo TransferMorph | #initDraggedMorph. Asi los morphs se arrancan con un string chiquito.

- MW-Fixes
	- Arregla el destinatario de #clipboardText
	- Se instalaba mal la property #bindings del mundo

- MW-MethodsInsideSystemWindows
	- Agrega dos preferencias. Una para decir si los metodos se ven dentro de SystemWindows o no, y otra para activar el efecto de carrying cuando los MW ingresan al mundo.
	- El carrying quedo desactivado porque ya no uso el metodo runAndAttachTo: 
	- Arregle el menu de los MethodModels 

- ManualWindowPlacement
	- Agrega una preferencia. Con la preferencia activada, las ventanas no muy grandes se pegan al mouse. 

- MW-ObjectExplorer-Extensions
	- Ahora se puede escribir en el aire, a los objetos que estan dentro de un ObjectExplorer. 
	- No hay que clickear para seleccionar el item. Esto sucede cuando el mouse esta encima del objeto. Le da un toque mas consistente con los MW

- MW-pancho
	- Extensiones a la imagen basica
	- Extensiones a los MW
	- Modificaciones de algunos metodos de los MW

- MW-DragAndDrop
	- Ahora es posible arrancar los metodos de listas de senders e implementors. Mejore un poco el mecanismo eliminado ifs.
	- Ahora se pueden agarrar los items de casi cualquier lista !!!!!! Browser, Debugger, ChangeSorter, ObjectExplorer, etc.
	- En cada modelo hay un solo metodo que controla cual el modelo para hacer el drag. Fijarse en #getItemAt:fromListNamed:. Tambien tuve que cambiar el #startDrag:. 
	- En todas las listas si se aprieta shift, se dragea la clase (en lugar del objeto).

"! !

!MorphicWrapper class methodsFor: 'documentation' stamp: 'fg 12/9/2001 19:01'!
history
"
Dear MW hacker: put a comment with the changes you introduce here.

[sd Dec 2001]
- add two hooks 
	transformTypedCode:  
	treatResult:forHand: 
which allows the morph to customize the typed string and the result returned.

[fg 11/28/2001 14:50]
- Generate a new MW distribution with Stephane Ducasse changes.
- I revert to the original version the method HandMorph>>newKeyboardFocus:, and I rename Leandro's version to HandMorph>>xxxnewKeyboardFocus: (so as to keep a copy). I revert this version because Leandro's version was always setting the keyboardFlocus with the world (aPasteUpMorph). I don't understand if this is necessary, but it interfered with the A2Emulator.

[Stephane Ducasse (sd) Nov 2001]
- Introduce a first set of hook methods in the class CodeBalloonMorph. 

- Second iteration introduce a MorphicWrapper configuration so that we can modify the font, classes....of the morphicwrapper. This may be too complex we will see in the future.

- There is two way of customising the morphic wrapper or you create new configuration or you subclass CodeBalloonMorph and CodeStringMorph.

[Francisco Garau (fg) Aug 2001]
Introduce several enhacements. 
See MorphicWrapper class fgVersions (in spanish).
See MorphicWrapper class toDo (in spanish).

[Leandro Caniglia (LC) Nov 1999]
See MorphicWrapper class initialComment
"
!
]style[(7 1171 31 19 25 53 35 3)f1b,f1,f1LMorphicWrapper class fgVersions;,f1,f1LMorphicWrapper class toDo;,f1,f1LMorphicWrapper class initialComment;,f1! !

!MorphicWrapper class methodsFor: 'documentation' stamp: 'fg 11/28/2001 10:58'!
initialComment
"
The MorphicWrapper package was originated by Luciano
Notarfrancesco and later extended by Gerardo Richiarte.
Valeria Murgia and Leandro Caniglia included the MW
programming tools (ClassWrappers, MethodModels, etc.).
Many ideas and code came from Pablo Malavolta,
Daniel Vaisencher and Alejandro Weil.

This version MW26 should be installed in a clean
Squeak 2.6.
Last updated by Francisco Garau, who also added this
new functionality:
 - Annotations panes in MethodModels.
 - Colored MethodModels
 - Optional writing of 'self' when you send a message to a MW.
 - Changes to the ObjectExplorer so you can write over each item
 as if it where a MW.
 - More control on the visual effects that are shown each time
 a new MW is added to the World.
 - New preference to control the printString that the ObjectExplorer
 shows. (Now it is possible to show the identity hash of each
 object... especially useful when you are exploring graphs).
 - New preference so that 'small' windows could be attached directly
 to the mouse.
 - New preference to control if you want each new MW to be added
 'as usual' to the World or inside an ObjectExplorer window (especially
 useful with Collections).
"! !

!MorphicWrapper class methodsFor: 'documentation' stamp: 'fg 8/26/2002 18:04'!
toDo
"
===
CampSmalltalk:
	- Cmd to enable/disable type in the air
		- #keystrokeInWorld: evt
	x tab
	x back tab
	- Ctrl-arrow inside CodeStringMorph to jump between words
	- fix the world bindings (declaring variables in the world).

===

[Ideas]
- CompositeChangeSet para agrupar varios ChangeSets y hacer fileOut una sola vez
- CompositeChangeSet deberia incluir un toDoList y un historyVersion 
- CompositeChangeSet deberia tener un metodo para encontrar los metodos que estan en mas de un ChangeSet.

- El drag de una categoria deberia traer la clase con la categoria seleccionada

- Los morphs deberian tener la posibilidad de captar los keystrokes directamente. Asi un StringMorph y un MorphicWrapper (sobre un String o Simbolo) podrian detectar el Cmd-m y entregar la lista de los implementors.

- MessageWrapper:
	- Con el autocompletion (apretando tab) se presentan los selectores que entiende un objeto. El receptor puede darse cuenta que le enviaron un selector que necesita argumentos y, en lugar de enviar el mensaje (que obviamente fallaria), se crea un MessageWrapper. Este wrapper tendria un RequestBoxMorph para cada argumento. Cuando todos los argumentos se completan, se envia el mensaje. 

- Hay que cambiar el aspecto visual de los MorphicWrapper. En lugar de tener un AlignmentMorph con un string, tendria que tener una lista jerarquica (como el ObjectExplorer). Esta lista se arma con colaboracion del propio objeto. Por default se ponen todas las variables de instancia (como el Inspector), pero las clases la podrian arma de forma especial. Cada uno de los elementos de esta lista podria ser pluggable (es decir, cuando se requiere su expansion, se ejecuta el selector asociado).

- La lista jeraquica de cada objeto, ademas de las variables de instancia podria tener (ordenado por categoria) los mensajes que entiende. Los mensajes se pueden draggear y tirar en el mundo. Si es un mensaje unario, se realiza el envio y se presenta el resultado. Si es un mensaje binario, se crea un MessageWrapper que queda a la espera de los demas argumentos. 

- Hay tres formas de crear MorphicWrappers:
	- Con Drag and Drop (TransferMorph | #justDroppedInto:event: )
	- Enviando mensajes con el menu del MW
	- (CodeBalloon class | #for:hand:) que termina llamando a (Morph | #acceptBalloon:)
		- Talk to me 
		- Tipeando en el aire
		- Tirando una string tipeado en el aire sobre un objeto (boton derecho) (MorphicWrapper | #acceptDroppingCode:event:)
	- Cuando se dropea un metodo sobre una clase

- Los ClassMorphicWrappers tendrian que tener la chance de interceptar los keyboard shortcuts. Cmd-o podria asociarse con un metod que haga new y luego open. 

[Drag an Drop]

x Habilitar el DnD desde la lista de implementors, senders, etc. 

x Cambiar el DnD de las clases. Cuando se agarra deberia mostrarse como un string y recien adoptar la forma de ClassMorphicWrapper cuando se suelta.

x Habiliatar DnD desde el ObjectExplorer. Fijarse como lo hace el inspector.

x No funciona el DnD de metodos sobre clases (con SystemWindows).

[System Windows]
x Poner el menu especifico del MethodModel en la ventana (quizas agregando otro menu...)

- Cuando se abre una ventana de MethodModel attachado al hand (ie con manualWindowPlacemente en 'on'), el scrollbar no aparece. Para que aparezca hay que salir de la ventana y volver a posicionar el mouse arriba de ella. Suena que simplemente hay que mandarle un evento...

- Habilitar colores

[Object Explorer]
- El root del OE no cambia aunque cambie el objeto. Tambien seria bueno tener un ballon help con el nombre de la clase.

[ClassMorphicWrapper]

- El wrapper de una clase deberia tener una lista jerarquica como el ObjectExplorer. Esta lista seria asi:
	- MiClase
		- class definition
			- superclass
				- superclase inmediata
				:
				- Object
			- instance variables
				- all inst vars
				- inst var 1
				- inst var n
			- class variables
			- pool dictionaries
			- clas category
				- lista con todas las clases de la categoria
			- comment
			- subclasses
				- lista con todas las subclases
		- instance methods
			- accessing
				- method 1
					- versiones
						- ultima version 
						- primera version
					- changeSets 
				- method n
			- printing
				- printOn:
		- class methods
			- category 1
				- method 1
		- recent methods
			- method 1
			- method n

Inicialmente este pseudo ObjectExplorer se abre de un tamanio chico mostrando unicamente lo siguiente.
	- MiClase
		- class definition
		- instance methods
		- class methods
		- recent methods
A medida que se expanden las listas, el morph crece automaticamente hasta un maximo determinado.


- Cambiar el menu para que se muestre en dos etapas. Categorias y operaciones por otro.

- Agregar un boton (o un menu...) para seleccionar la cantidad de informacion a mostrar en un CMW. 

- Agregar preferencia para mostrar/ocultar el identityHash
"! !


!ClassMorphicWrapper class methodsFor: 'instance creation' stamp: 'r++ 11/21/1998 20:36'!
canWrap: anObject
	^ anObject isKindOf: Behavior! !

!ClassMorphicWrapper class methodsFor: 'initialization' stamp: 'r++ 11/21/1998 20:07'!
initialize
	" ClassWrapper initialize " 
	Preferences enable: #allowSysWindowEmbedding! !


!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:54'!
borderColor

	^ defaultBorderColor ! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:55'!
borderColor: aColor

	 defaultBorderColor := aColor! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:54'!
borderWidth

	^ defaultBorderWidth ! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:54'!
borderWidth: anInteger

	defaultBorderWidth := anInteger! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/26/2001 23:03'!
codeBalloonMorphClass

	^ codeBalloonMorphClass! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/26/2001 23:03'!
codeBalloonMorphClass: aClass

	codeBalloonMorphClass := aClass! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/26/2001 23:03'!
codeStringMorphClass

	^ codeStringMorphClass! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/26/2001 23:03'!
codeStringMorphClass: aClass

	codeStringMorphClass := aClass! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:54'!
color

	^ defaultColor! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:57'!
color: aColor

	defaultColor := aColor! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 16:10'!
contents

	^ defaultContents! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 16:09'!
contents: aString

	defaultContents := aString! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:44'!
defaultContents

	^ defaultContents! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:44'!
defaultContents: aString

	defaultContents := aString! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:33'!
defaultFont

	^ defaultFont! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 15:33'!
defaultFont: aFont

	defaultFont := aFont! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 16:12'!
font

	^ defaultFont! !

!MorphicWrapperConfiguration methodsFor: 'accessing' stamp: 'sd 11/27/2001 16:12'!
font: aFont

	defaultFont := aFont! !

!MorphicWrapperConfiguration methodsFor: 'initialize' stamp: 'sd 11/27/2001 17:35'!
initialize
	
	self codeStringMorphClass: CodeStringMorph.
	self codeBalloonMorphClass: CodeBalloonMorph.
	self font: BalloonMorph balloonFont.
	self contents: ''.
	self color: (Color

r: 1.0

g: 1.0

b: 0.6).
	self borderWidth: 1.
	self borderColor: (Color black).! !


!MorphicWrapperConfiguration class methodsFor: 'example' stamp: 'fg 11/28/2001 11:35'!
defaultStyle
	"self defaultStyle"

	MorphicWrapperConfiguration uniqueInstance
		font: (StrikeFont familyName: #ComicPlain size: 13) ;
		contents: '  ';
		color: ((Color r: 1.0 g: 1.0 b: 0.6) alpha: 0.8); 	
		borderColor: Color red
	! !

!MorphicWrapperConfiguration class methodsFor: 'example' stamp: 'fg 9/9/2002 23:46'!
niceStyle
	"self niceStyle"

	MorphicWrapperConfiguration uniqueInstance
		font: (StrikeFont familyName: #ComicPlain size: 17) ;
		contents: '  ';
		color: ((Color r: 1.0 g: 1.0 b: 0.6) alpha: 0.9); 	
		borderColor: (Color r: 1 g: 0.2 b: 0.2)
	! !

!MorphicWrapperConfiguration class methodsFor: 'instance creation' stamp: 'sd 11/26/2001 22:59'!
new

	self error: 'use unique instance to get an instance'! !

!MorphicWrapperConfiguration class methodsFor: 'instance creation' stamp: 'sd 11/27/2001 17:39'!
reset
	"self reset"

	uniqueInstance := nil! !

!MorphicWrapperConfiguration class methodsFor: 'instance creation' stamp: 'sd 11/26/2001 22:59'!
uniqueInstance

	uniqueInstance isNil
		ifTrue: [uniqueInstance := self basicNew initialize].
	^ uniqueInstance! !


!RequestBoxMorph methodsFor: 'dropping/grabbing' stamp: 'LC 11/19/1998 12:36'!
acceptDroppingMorph: aMorph event: evt
	| answer |
	answer _ super acceptDroppingMorph: aMorph event: evt.
	self response: aMorph.
	^ answer

! !

!RequestBoxMorph methodsFor: 'dropping/grabbing' stamp: 'LC 11/18/1998 20:11'!
wantsDroppedMorph: aMorph event: evt
	^ response isNil! !

!RequestBoxMorph methodsFor: 'private' stamp: 'LC 12/24/1998 13:02'!
attachToHand
	"Answer the hand."
	| w |
	w _ self world ifNil: [World addMorph: self].
	w ifNil: [^ self halt: 'Request not in the world'].
	^ hand _ w activeHand
		attachMorph: self;
		yourself! !

!RequestBoxMorph methodsFor: 'private' stamp: 'LC 12/24/1998 13:14'!
getUserResponse
	| w |
	response _ nil.
	w _ self attachToHand world.
	[response isNil and: [self isInWorld]] whileTrue: [w doOneCycle].
	self shake.
	self delete.
	^ self response
! !

!RequestBoxMorph methodsFor: 'private' stamp: 'LC 11/19/1998 12:23'!
request: aString
	self setRequest: aString.
	self getUserResponse! !

!RequestBoxMorph methodsFor: 'private' stamp: 'LC 11/19/1998 12:46'!
request: aString respondTo: anObject selector: aSelector 
	self setRequest: aString.
	self attachToHand.
	destiny _ anObject.
	selector _ aSelector.
	response _ nil! !

!RequestBoxMorph methodsFor: 'private' stamp: 'LC 11/19/1998 17:53'!
response: aMorph 
	| answer |
	self shake.
	response _ aMorph.
	(destiny notNil and: [selector notNil])
		ifTrue: [answer _ destiny perform: selector with: self response].
	self delete.
	(destiny respondsTo: #surroundedBy:)
		ifTrue: [destiny surroundedBy: (Array with: answer)]! !

!RequestBoxMorph methodsFor: 'private' stamp: 'LC 11/19/1998 12:22'!
setRequest: aString
	| request |
	self removeAllMorphs.
	request _ StringMorph
		contents: aString
		font: (StrikeFont familyName: 'ComicBold' size: 24).
	self addMorph: request! !

!RequestBoxMorph methodsFor: 'accessing' stamp: 'LC 12/24/1998 13:11'!
hand
	^ hand! !

!RequestBoxMorph methodsFor: 'accessing' stamp: 'LC 12/24/1998 13:10'!
hand: aHandMorph
	hand _ aHandMorph! !

!RequestBoxMorph methodsFor: 'accessing' stamp: 'LC 5/14/2000 08:55'!
response
	self delete.
	^ response isMorphicWrapper
		ifTrue: [response wrapee]
		ifFalse: [response]! !

!RequestBoxMorph methodsFor: 'initialization' stamp: 'r++ 11/21/1998 20:47'!
initialize
	super initialize.
	self borderWidth: 2.
	orientation _ #vertical.  	"#horizontal or #vertical  or #free"
	centering _ #center.		"#topLeft, #center, or #bottomRight"
	hResizing _ #spaceFill.		"#spaceFill, #shrinkWrap, or #rigid"
	vResizing _ #spaceFill.		"#spaceFill, #shrinkWrap, or #rigid"
	openToDragNDrop _ false.	"objects can be dropped in or dragged out"
	self color: Color red
! !


!RequestBoxMorph class methodsFor: 'instance creation' stamp: 'LC 11/18/1998 16:36'!
request: aString
	^ (self new request: aString) response! !

!RequestBoxMorph class methodsFor: 'instance creation' stamp: 'LC 11/19/1998 12:39'!
request: aString respondTo: anObject selector: aSelector
	"Request a response to the user prompting her with aString.
	Then sends the response to anObject using the unary selector
	aSelector"
	^ self new
		request: aString
		respondTo: anObject
		selector: aSelector;
	 yourself! !


!RequestMorph methodsFor: 'all' stamp: 'LC 10/26/1998 12:32'!
getUserResponse
	| w |
	response _ nil.
	self hand startReportingEventsTo: self.
	w _ self world
		ifNil:
			[self hand world
				addMorph: self;
				yourself].
	w ifNil: [^ self halt: 'Request not in the world'].
	self startStepping.
	[response isNil] whileTrue: [w doOneCycle].
	self delete.
	^ self response
! !

!RequestMorph methodsFor: 'all' stamp: 'LC 10/26/1998 00:45'!
hand
	^ target! !

!RequestMorph methodsFor: 'all' stamp: 'LC 10/26/1998 02:09'!
handleEvent: evt
	| morph |
	evt redButtonPressed ifFalse: [^ self].
	morph _ self hand recipientForMouseDown: evt.
	morph isNil ifTrue: [^ self].
	morph isWorldOrHandMorph ifTrue: [^ self].
	(morph isKindOf: MenuMorph) ifTrue: [^ self].
	(morph isKindOf: MenuItemMorph) ifTrue: [^ self].
	morph == self ifTrue: [^ self].
	self hand stopReportingEventsTo: self.
	response _ morph.
	self stop.
	self shake
! !

!RequestMorph methodsFor: 'all' stamp: 'LC 5/14/2000 08:55'!
response
	^ response isMorphicWrapper
		ifTrue: [response object]
		ifFalse: [response]! !

!RequestMorph methodsFor: 'all' stamp: 'LC 11/16/1998 12:54'!
step
	response isNil ifFalse: [^ self].
	super step! !


!RequestMorph class methodsFor: 'instance creation' stamp: 'VM 2/4/1999 03:00'!
request: queryString
	^ self request: queryString with: World activeHand
! !

!RequestMorph class methodsFor: 'instance creation' stamp: 'LC 10/26/1998 12:27'!
request: queryString with: aHandMorph
	^ (self string: queryString for: aHandMorph corner: #bottomRight)
		getUserResponse! !


!SatelliteMorph methodsFor: 'drawing' stamp: 'LC 6/17/1999 15:47'!
fullBounds
	| old |
	self flag: #XXX. 	"this is due to an error in EllipseMorph bounds
					computation... they forgot the border. len 10/1/1998 07:44"
	old _ super fullBounds.
	^ old topLeft - (1 @ 1) extent: old extent + (2 @ 2)! !

!SatelliteMorph methodsFor: 'stepping' stamp: 'LC 6/17/1999 20:22'!
step
	| direction length |
	self owner isNil ifTrue: [^ self].
	ticks1 _ ticks1 + increment1 \\ 360.
	ticks2 _ ticks2 + increment2 \\ 360.
	direction _ ticks1 degreeCos @ ticks2 degreeSin.
	length _ ticks1 degreeSin @ ticks2 degreeCos * self owner extent // 2 * delta.
	self position: direction * length + self owner center - (self extent // 2)! !

!SatelliteMorph methodsFor: 'stepping' stamp: 'len 10/1/1998 00:43'!
stepTime
	^ 50! !

!SatelliteMorph methodsFor: 'initialization' stamp: 'LC 6/17/1999 16:24'!
initialize
	| diam |
	super initialize.
	self extent: (diam _ 4 + 4 atRandom) @ diam.
	self color: Color random.
	self borderWidth: 0.
	ticks1 _ 360 atRandom.
	ticks2 _ 360 atRandom.
	increment1 _ 20 atRandom.
	increment2 _ 10 atRandom.
	delta _ 2.0 @ 2.0
! !

!SatelliteMorph methodsFor: 'initialization' stamp: 'len 10/1/1998 06:29'!
setDelta: aPoint
	delta _ aPoint asPoint! !


!DeferredMessageMorph methodsFor: 'accessing' stamp: 'LC 6/17/1999 19:57'!
deferForever
	sendTime _ nil.
	self startStepping! !

!DeferredMessageMorph methodsFor: 'accessing' stamp: 'LC 6/17/1999 19:44'!
deferSend: theseSeconds
	sendTime _ theseSeconds * 1000 + Time millisecondClockValue.
	self startStepping! !

!DeferredMessageMorph methodsFor: 'accessing' stamp: 'LC 6/17/1999 18:05'!
reset
	sendTime _ Time millisecondClockValue + 10000 "10 seconds"! !

!DeferredMessageMorph methodsFor: 'accessing' stamp: 'LC 6/17/1999 17:21'!
setSelector: aSymbol receiver: anObject arguments: aCollection 
	selector _ aSymbol.
	receiver _ anObject.
	arguments _ (aCollection isKindOf: Collection)
				ifTrue: [aCollection]
				ifFalse: [Array with: aCollection]! !

!DeferredMessageMorph methodsFor: 'stepping' stamp: 'LC 6/17/1999 17:14'!
step
	| answer |
	(sendTime notNil and: [Time millisecondClockValue > sendTime])
		ifTrue: 
			[answer _ receiver perform: selector withArguments: arguments.
			self stop.
			^ answer]
		ifFalse: [super step]! !

!DeferredMessageMorph methodsFor: 'stepping' stamp: 'LC 6/17/1999 17:11'!
stop
	super stop.
	self delete! !


!SatelliteMorph class methodsFor: 'examples' stamp: 'LC 6/17/1999 15:41'!
example1
	| m s |
	World addMorph: (m _ EllipseMorph new extent: 60 @ 60; position: 200 @ 200).
	m addMorph: (s _ SatelliteMorph new).
	s startStepping
"
SatelliteMorph example1
"! !

!SatelliteMorph class methodsFor: 'examples' stamp: 'LC 6/17/1999 15:44'!
example2
	| m s s2 |
	World addMorph: (m _ EllipseMorph new extent: 60 @ 60; position: 200 @ 200).
	m addMorph: (s _ SatelliteMorph new).
	s startStepping.
	s addMorph: (s2 _ SatelliteMorph new).
	s2 setDelta: 3.0.
	s2 startStepping
"
SatelliteMorph example2
"! !

!SatelliteMorph class methodsFor: 'instance creation' stamp: 'LC 6/17/1999 16:27'!
duration: theseSeconds
	^ self new stopWithin: theseSeconds	! !


!DeferredMessageMorph class methodsFor: 'instance creation' stamp: 'LC 6/17/1999 17:24'!
in: n send: selector to: receiver 
	^ self
		in: n
		send: selector
		to: receiver
		withArguments: Array new! !

!DeferredMessageMorph class methodsFor: 'instance creation' stamp: 'LC 6/17/1999 17:16'!
in: n send: selector to: receiver withArguments: arguments 
	^ self new
		setSelector: selector
		receiver: receiver
		arguments: arguments;
	 deferSend: n "seconds"! !

!DeferredMessageMorph class methodsFor: 'instance creation' stamp: 'LC 6/22/1999 01:02'!
includeInNewMorphMenu
	^ false! !


!ShakingMorph methodsFor: 'stepping' stamp: 'LC 6/20/1999 20:09'!
step
	| xsign ysign coef |
	index > intensity
		ifTrue: 
			[target position: origin.
			^ self stop].
	coef _ intensity / 20.
	xsign _ (index \\ 3 - 1) sign.
	ysign _ (index + 1 \\ 3 - 1) sign.
	target position: (30 // index * xsign @ (30 // index * ysign) * coef) rounded + origin.
	index _ index + 1.
	target globe! !

!ShakingMorph methodsFor: 'stepping' stamp: 'LC 6/19/1999 21:14'!
stepTime
	^ (10 * intensity / 20) rounded! !

!ShakingMorph methodsFor: 'stepping' stamp: 'LC 6/19/1999 21:11'!
stop
	super stop.
	self delete! !

!ShakingMorph methodsFor: 'accessing' stamp: 'LC 6/19/1999 20:59'!
intensity: n
	intensity _ n! !

!ShakingMorph methodsFor: 'accessing' stamp: 'LC 6/19/1999 21:07'!
target: aMorph
	target _ aMorph.
	origin _ target position! !

!ShakingMorph methodsFor: 'initialization' stamp: 'LC 6/19/1999 21:04'!
initialize
	super initialize.
	self extent: 3 @ 3.
	self stopStepping.
	index _ 1.
	origin _ 0 @ 0! !


!ShakingMorph class methodsFor: 'instance creation' stamp: 'LC 6/22/1999 01:05'!
includeInNewMorphMenu
	^ false! !

!ShakingMorph class methodsFor: 'instance creation' stamp: 'LC 6/19/1999 21:12'!
shake: aMorph 
	^ self shake: aMorph intensity: 20! !

!ShakingMorph class methodsFor: 'instance creation' stamp: 'LC 6/19/1999 21:12'!
shake: aMorph intensity: n 
	| answer |
	answer _ self new target: aMorph;
			 intensity: n.
	aMorph isInWorld ifFalse: [^ answer].
	aMorph world addMorph: answer.
	answer hide.
	answer startStepping.
	^ answer! !


!SimpleBook methodsFor: 'initialization' stamp: 'LC 10/31/1998 09:45'!
addDressing
	| controlColor pageControls string |
	self halt.
	controlColor _ (color saturation > 0.1)
		ifTrue:
			[color lighter]
		ifFalse:
			[color darker].
	pageControls _ self makeAuthoringPageControlsColored: controlColor.
	pageControls borderWidth: 1; inset: 4.
	string _ TextMorph new contents: 'unnamed'.
	string setNameTo: 'Name'.
	pageControls
		addMorph: string;
		color: (Color r: 1.0 g: 0.599 b: 0.4).
	self addMorph: pageControls
! !

!SimpleBook methodsFor: 'initialization' stamp: 'LC 10/31/1998 10:13'!
makePageControlsFrom: controlSpecs
	| string |
	string _ TextMorph new contents: 'unnamed'.
	string setNameTo: 'Name'.
	^ (super makePageControlsFrom: controlSpecs)
		addMorph: string;
		color: (Color r: 1.0 g: 0.599 b: 0.4)
! !

!SimpleBook methodsFor: 'initialization' stamp: 'LC 9/14/1998 22:38'!
setInitialState
	super setInitialState.
	pageSize _ 360 @ 400.
	color _ Color r: 0 g: 0.6 b: 0.6
! !

!SimpleBook methodsFor: 'accessing' stamp: 'LC 9/12/1998 17:50'!
nameMorph
	^ self pageControls allMorphs detect: [:one | one knownName = 'Name']! !

!SimpleBook methodsFor: 'accessing' stamp: 'LC 9/12/1998 17:50'!
pageControls
	^ self allMorphs detect: [:one | one knownName = 'Page Controls']! !

!SimpleBook methodsFor: 'file out' stamp: 'LC 9/12/1998 15:19'!
saveOnFile
	"Overide Morph|saveOnFile to use the book's name."
	| fileName fileStream |
	fileName _ self name asFileName. "do better?"
	fileName _ FillInTheBlank
		request: 'File name? (".morph" will be added to end)' 
		initialAnswer: fileName.
	fileName size == 0 ifTrue: [^ self beep].
	self allMorphsDo: [:m | m prepareToBeSaved].
	fileStream _ FileStream newFileNamed: fileName,'.morph'.
	fileStream fileOutClass: nil andObject: self.	"Puts UniClass definitions out anyway"
	! !

!SimpleBook methodsFor: 'menu' stamp: 'LC 9/12/1998 13:21'!
addBookMenuItemsTo: aCustomMenu hand: aHandMorph
	aCustomMenu
		addLine;
		add: 'save on file' action: #saveOnFile;
		addLine
! !

!SimpleBook methodsFor: 'menu' stamp: 'LC 9/14/1998 22:02'!
insertPage
	self insertPageColored: (Color r: 1.0 g: 1.0 b: 0.8)
! !

!SimpleBook methodsFor: 'menu' stamp: 'LC 10/31/1998 10:22'!
invokeBookMenu
	"Overiden to suit our needs."
	| aMenu sel |
	aMenu _ MVCMenuMorph new.
	aMenu addList:	#(
			('sort pages'				sortPages)
			('make bookmark'		bookmarkForThisPage)
			('make thumbnail'		thumbnailForThisPage)
			('remove control panel'	hidePageControls)
		).
	(self primaryHand classOfPasteBuffer isKindOf: PasteUpMorph class) ifTrue:
		[aMenu add: 'paste book page'	action: #pasteBookPage].

	aMenu add: 'save as new-page prototype' action: #setNewPagePrototype.
	newPagePrototype ifNotNil: [
		aMenu add: 'clear new-page prototype' action: #clearNewPagePrototype].

	aMenu add: (openToDragNDrop ifTrue: ['close'] ifFalse: ['open']) , ' dragNdrop'
			action: #openCloseDragNDrop.

	aMenu
		addLine;
		add: 'save on file' action: #saveOnFile;
		add: 'rename' action: #rename;
		add: 'add text' action: #newTextMorph.

	sel _ aMenu invokeAt: self primaryHand position in: self world.
	sel ifNotNil: [self perform: sel].
! !

!SimpleBook methodsFor: 'menu' stamp: 'LC 10/31/1998 11:02'!
newTextMorph
	"Create a new, empty TextMorph that can be placed in this book."
	| text |
	text _ TextMorph new
		string: 'Text for editing'
		fontName: 'ComicPlain'
		size: 16;
		justified.
	self currentPage submorphs isEmpty
		ifTrue:
			[self currentPage addMorph: text.
			text fillingOnOff.
			text container
				fillsOwner: true;
				avoidsOcclusions: true]
		ifFalse:
			[self isInWorld ifTrue: [self primaryHand attachMorph: text]]! !

!SimpleBook methodsFor: 'naming' stamp: 'LC 9/12/1998 21:23'!
name
	| morph |
	^ (morph _ self nameMorph)
		ifNil: ['']
		ifNotNil: [morph contents asString]! !

!SimpleBook methodsFor: 'naming' stamp: 'LC 9/12/1998 18:01'!
name: aString
	| morph h |
	self renameTo: aString.
	morph _ self nameMorph.
	h _ morph height.
	morph contents: aString.
	morph height: h.! !

!SimpleBook methodsFor: 'naming' stamp: 'LC 9/12/1998 14:07'!
rename
	| answer |
	answer _ FillInTheBlank request: 'Give the book a new name' initialAnswer: self name.
	answer size = 0 ifFalse: [self name: answer]! !


!SimpleBook class methodsFor: 'instance creation' stamp: 'LC 9/13/1998 01:56'!
fromBook: aBookMorph
	| answer |
	answer _ self new.
	answer pages: aBookMorph pages.
	^ answer! !

ClassMorphicWrapper initialize!

!MethodModel reorganize!
('accessing' classField classification classification: contents labelString methodClass methodSelector selector source)
('menu' addCategory addMenuForClass:toMenu:isSuperOf: addModelItemsToWindowMenu: addModelMenuItemsTo:forMorph:hand: buildMenuInto: implementors localImplementors localSenders messageListMenu:shifted: parseTree prettyPrint projectImplementors projectSenders remove senders showBytecodes)
('private' changeClass: changeClass:copy: changeClass:remove: class:selector: contents:notifying: defaultBackgroundColor messageListIndex modelWakeUp privateRemove selectedClass selectedClassOrMetaClass selectedMessageCategoryName selectedMessageName updateClass)
('opening' annotationsPane asMorph buildMethodMathMorph contentsPane grabMethod initialExtent openAsMorph openAttachedTo: openMethodMathMorph openSystemWindowMorph)
('printing' printOn:)
('morphic wrappers' hasNiceWrapper wrappedClass)
!

GlobingMorph initialize!
