'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5325] on 30 July 2003 at 10:11:47 pm'!
"Change Set:		MW-Loader
Date:			30 July 2003
Author:			Francisco Garau

See the MorphicWrapper class>>history for more documentation about the MW package.

First Steps:
1- Load this ChangeSet
2- Move the mouse to the World and press Tab (a balloon will appear)
3- Type 'Date today' (or any Smalltalk expression) and press Enter.
4- A MorphicWrapper will appear on the world. 
5- Put the mouse over the new MorphicWrapper. It will change the color and tell you 'I am a Date'.
6- With the mouse over the MorphicWrapper press Tab, type 'year' and press Enter.
7- Reposition the mouse over the MorphicWrapper and press Tab. Type 'add' and press Tab again.
 This version features autocompletion of messages, so the message 'add' on a Date object will be expanded to 'addDays:'. Complete the message to something like 'addDays: 7'.

Advanced Steps:
Steps 1 and 2 like before
3- Type 'EllipseMorph new'
4- An EllipseMorph will appear on the world. This is a regular morph, so if you put the mouse over it, you won't see 'I am an EllipseMorph'.
5- With the mouse over the ellipse, press Tab and type 'color'.
6- The resulting Color object is wrapped into an ObjectExplorer.
7- Go to the ObjectExplorer window and position the mouse on the root item
8- Press Tab and type 'red'
9- A MorphicWrapper on the number 1.0 will be attached to the mouse.

For the Corageous:
1- Open a new Browser window
2- Click on any class, drag it and drop it on the World (or anywhere outside the Browser window)
3- You will get a rectangular morph representing the class (an instance of ClassMorphicWrapper).
4- Put the mouse over the class morphic wrapper and send it the message 'superclass' or 'browseHierarchy'
5- Play around dropping other objects into the world from different windows (I specially like dropping ChangeSets)


"!

"Postscript:
	Load the MW ChangeSets in the appropiate order
"

ChangeSorter 
	fileIntoNewChangeSet: 'MW-base.2.cs';
	fileIntoNewChangeSet: 'MW-extensions.2.cs';
	fileIntoNewChangeSet: 'MW-explorer.2.cs';
	fileIntoNewChangeSet: 'MW-dragAndDrop.2.cs';
	yourself!

